;************************************************
;* MegaJolt Lite Junior Ignition Controller
;* Copyright 2003-2007 Autosport Labs
;* http://www.autosportlabs.net
;* Contains Code Derived from
;* Bruce Bowling and Al Grippo		
;* http://www.bgsoflex.com/mjl/mjl_edis.html				
;                Autosport Labs 'Open Kimono' License
;   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
;
;  0. This License applies to any program or other work which contains
;a notice placed by the copyright holder saying it may be distributed
;under the terms of this License.  The "Program" as defined herein,
;listed below (or bundled with this file) refers to any such program,
;and a "work based on the Program" means either the Program or any derivative 
;work under copyright law: that is to say, a work containing the Program 
;or a portion of it, either verbatim or with modifications and/or 
;translated into another language.  (Hereinafter, translation is 
;included without limitation in the term "modification".)  
;Each licensee is addressed as "you".
;
;The Term "Program" or "Work" is strictly limited to computer programming 
;code (also known as "Software" or "Firmware") and specifically does not 
;include Electronic Designs ("Schematics"), Printed Circuit Board designs, 
;code for any type of Programmble Logic Device (FPGAs, PALs, etc), or 
;Mechanical designs.
;
;Activities other than copying, distribution and modification are not
;covered by this License; they are outside its scope.  The act of
;running the Program is not restricted, and the output from the Program
;is covered only if its contents constitute a work based on the
;Program (independent of having been made by running the Program).
;Whether that is true depends on what the Program does.
;
;NO FALSE REPRESENTATIONS
;  1. The origin of this program must not be misrepresented; you must 
;  not claim that you wrote the original program. Modified versions of
;  the program as permitted by Section 3 must be plainly marked as such, 
;  and must not be misrepresented as being the original program.
;  
;  2. You may copy and distribute verbatim copies of the Program's
;source code as you receive it, in any medium, provided that you
;conspicuously and appropriately publish on each copy an appropriate
;copyright notice and disclaimer of warranty; keep intact all the
;notices that refer to this License and to the absence of any warranty;
;and give any other recipients of the Program a copy of this License
;along with the Program.
;
;You may charge a fee for the physical act of transferring a copy, and
;you may at your option offer warranty protection in exchange for a fee.
;
;NON COMMERCIAL DERIVATIVE WORKS
;  3. You may modify your copy or copies of the Program or any portion
;of it, thus forming a work based on the Program, and copy and
;distribute such modifications or work under the terms of Section 2
;above, provided that you also meet all of these conditions:
;
;    a) You are (1) a Non-Commercial Entity as defined herein, or (2) an
;    Excluded Contractor as defined herein.
;    
;    b) You must cause the modified files to carry prominent notices
;    stating that you changed the files and the date of any change.
;
;    c) You must cause any work that you distribute or publish, that in
;    whole or in part contains or is derived from the Program or any
;    part thereof, to be licensed as a whole at no charge to all third
;    parties under the terms of this License.
;
;    d) You must not modify the program with the intention of enabling,
;    either directly or indirectly, interoperability with electronic devices 
;    and software/firmware programs other than those originally developed
;    and/or authored by Autosport Labs LLC without explicit written approval 
;    from the author.
;    
;    e) If the modified program normally reads commands interactively
;    when run, you must cause it, when started running for such
;    interactive use in the most ordinary way, to print or display an
;    announcement including an appropriate copyright notice and a
;    notice that there is no warranty (or else, saying that you provide
;    a warranty) and that users may redistribute the program under
;    these conditions, and telling the user how to view a copy of this
;    License.  (Exception: if the Program itself is interactive but
;    does not normally print such an announcement, your work based on
;    the Program is not required to print an announcement.)
;
;The term "Non-Commercial Entity" is limited to the following: 
;university or other educational institutions (such as pre-schools, 
;elementary schools, middle or junior high schools, high schools, 
;and community or junior colleges), non-profit organizations 
;(such as public libraries, charities, and other organizations created 
;for the promotion of social welfare), "University Users", and other 
;individual users who will use and modify the Software for personal use 
;(such as hobby, recreational or educational purposes), and the entity 
;that developed the original work (Autosport Labs LLC) which the 
;derivative was based upon, either directly or indirectly.
;The term "University Users" is limited to students, faculty members, 
;researchers, administrators, support staff, and employees of a 
;university when acting in this capacity. The term "Excluded Contractor" 
;is limited to independent, solo contractors while performing work 
;for a Non-Commercial Entity, such as a university or other educational 
;institution in an individual capacity. The copyright holder
;reserves the right to further clarify the terms Non-Commercial Entity, 
;University Users and Excluded Contractor at its sole determination.
;
;These requirements apply to the modified work as a whole.  If
;identifiable sections of that work are not derived from the Program,
;and can be reasonably considered independent and separate works in
;themselves, then this License, and its terms, do not apply to those
;sections when you distribute them as separate works.  But when you
;distribute the same sections as part of a whole which is a work based
;on the Program, the distribution of the whole must be on the terms of
;this License, whose permissions for other licensees extend to the
;entire whole, and thus to each and every part regardless of who wrote it.
;
;Thus, it is not the intent of this section to claim rights or contest
;your rights to work written entirely by you; rather, the intent is to
;exercise the right to control the distribution of derivative or
;collective works based on the Program.
;
;In addition, mere aggregation of another work not based on the Program
;with the Program (or with a work based on the Program) on a volume of
;a storage or distribution medium does not bring the other work under
;the scope of this License.
;
;  4. You may copy and distribute the Program (or a work based on it,
;under Section 2) in object code or executable form under the terms of
;Sections 1 and 2 above provided that you also do one of the following:
;
;    a) Accompany it with the complete corresponding machine-readable
;    source code, which must be distributed under the terms of Sections
;    1 and 2 above on a medium customarily used for software interchange; or,
;
;    b) Accompany it with a written offer, valid for at least three
;    years, to give any third party, for a charge no more than your
;    cost of physically performing source distribution, a complete
;    machine-readable copy of the corresponding source code, to be
;    distributed under the terms of Sections 1 and 2 above on a medium
;    customarily used for software interchange; or,
;
;    c) Accompany it with the information you received as to the offer
;    to distribute corresponding source code.  (This alternative is
;    allowed only for noncommercial distribution and only if you
;    received the program in object code or executable form with such
;    an offer, in accord with Subsection b above.)
;
;The source code for a work means the preferred form of the work for
;making modifications to it.  For an executable work, complete source
;code means all the source code for all modules it contains, plus any
;associated interface definition files, plus the scripts used to
;control compilation and installation of the executable.  However, as a
;special exception, the source code distributed need not include
;anything that is normally distributed (in either source or binary
;form) with the major components (compiler, kernel, and so on) of the
;operating system on which the executable runs, unless that component
;itself accompanies the executable.
;
;If distribution of executable or object code is made by offering
;access to copy from a designated place, then offering equivalent
;access to copy the source code from the same place counts as
;distribution of the source code, even though third parties are not
;compelled to copy the source along with the object code.
;
;  5. You may not copy, modify, sublicense, or distribute the Program
;except as expressly provided under this License.  Any attempt
;otherwise to copy, modify, sublicense or distribute the Program is
;void, and will automatically terminate your rights under this License.
;However, parties who have received copies, or rights, from you under
;this License will not have their licenses terminated so long as such
;parties remain in full compliance.
;
;  6. You are not required to accept this License, since you have not
;signed it.  However, nothing else grants you permission to modify or
;distribute the Program or its derivative works.  These actions are
;prohibited by law if you do not accept this License.  Therefore, by
;modifying or distributing the Program (or any work based on the
;Program), you indicate your acceptance of this License to do so, and
;all its terms and conditions for copying, distributing or modifying
;the Program or works based on it.
;
;  7. Each time you redistribute the Program (or any work based on the
;Program), the recipient automatically receives a license from the
;original licensor to copy, distribute or modify the Program subject to
;these terms and conditions.  You may not impose any further
;restrictions on the recipients' exercise of the rights granted herein.
;You are not responsible for enforcing compliance by third parties to
;this License.
;
;  8. If, as a consequence of a court judgment or allegation of patent
;infringement or for any other reason (not limited to patent issues),
;conditions are imposed on you (whether by court order, agreement or
;otherwise) that contradict the conditions of this License, they do not
;excuse you from the conditions of this License.  If you cannot
;distribute so as to satisfy simultaneously your obligations under this
;License and any other pertinent obligations, then as a consequence you
;may not distribute the Program at all.  For example, if a patent
;license would not permit royalty-free redistribution of the Program by
;all those who receive copies directly or indirectly through you, then
;the only way you could satisfy both it and this License would be to
;refrain entirely from distribution of the Program.
;
;If any portion of this section is held invalid or unenforceable under
;any particular circumstance, the balance of the section is intended to
;apply and the section as a whole is intended to apply in other
;circumstances.
;
;It is not the purpose of this section to induce you to infringe any
;patents or other property right claims or to contest validity of any
;such claims; this section has the sole purpose of protecting the
;integrity of the free software distribution system, which is
;implemented by public license practices.  Many people have made
;generous contributions to the wide range of software distributed
;through that system in reliance on consistent application of that
;system; it is up to the author/donor to decide if he or she is willing
;to distribute software through any other system and a licensee cannot
;impose that choice.
;
;This section is intended to make thoroughly clear what is believed to
;be a consequence of the rest of this License.
;
;  9. If the distribution and/or use of the Program is restricted in
;certain countries either by patents or by copyrighted interfaces, the
;original copyright holder who places the Program under this License
;may add an explicit geographical distribution limitation excluding
;those countries, so that distribution is permitted only in or among
;countries not thus excluded.  In such case, this License incorporates
;the limitation as if written in the body of this License.
;
;  10. If you wish to incorporate parts of the Program into other free
;programs whose distribution conditions are different, write to the author
;to ask for permission.  For software which is copyrighted by the Free
;Software Foundation, write to the Free Software Foundation; we sometimes
;make exceptions for this.  Our decision will be guided by the two goals
;of preserving the free status of all derivatives of our free software and
;of promoting the sharing and reuse of software generally.
;
;			    NO WARRANTY
;
;  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
;FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
;OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
;PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
;OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
;MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
;TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
;PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
;REPAIR OR CORRECTION.
;
;  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
;WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
;REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
;INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
;OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
;TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
;YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
;PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
;POSSIBILITY OF SUCH DAMAGES.
;
;                Copyright  2004-2007 Autosport Labs LLC
;
;		     END OF TERMS AND CONDITIONS
;
;Description:
;
;an Internal Combustion Engine ignition controller
;designed to work with the Ford EDIS ignition
;control module
; 
; Updates:
; 7/2/2004  - Added KPA factor table and lookup to correct errors in MAP sensor readings
; 6/18/2005 - Added linear interpolation for ignition map
; 			- Fixed incorrect User defined output triggering - was triggering 100 RPM off
;			- Cleaned up startup routine. Fixed incorrect triggering of outputs during cranking RPM
;			- Added soft rev limiter. Advance goes to zero degrees 100 RPM before configured hard rev limit.
;				At configured rev limit, external output is enabled, and external circuitry can disable the ignition coils.
;			- Fixed problem when write flash is peformed, goes into endless loop trying to process sending of data out of controller
;			- Enabled Watchdog (Computer Operating Properly)
;			- Changed default ignition map to something sane that would work for both normally aspirated and boosted applications.
; 7/15/2005 - Updates for 3.0.0: removed use of hardware interrupt and changed to an IRQ level polling mechanism. This was due to using the MAX232
;			  for input filtering; the MAX232 inverts the PIP signal. Falling edge IRQ is no longer appropriate.
; 9/30/2006 - Fixes for Read configuruation getting munged at higher RPMs. Moved MAP sensor reading to a interrupt to prevent
; 			  wasting CPU cycles waiting for ADC read to complete
;			`	Moved RPM and advance calculation to PIP interrupt routine to separate from main-line logic
; 11/5/2006 - Implemented 'Version' Command
; 12/23/2006 - Implemented 'GetRawADC' command 
; 12/23/2006 - Implemented 'UpdateLoadCalibration' command 
; 12/26/2006 - Implemented 'GetLoadCalibration' Command 
; 12/27/2006 - First cut at Load calibration support. KPAFACTOR renamed to 'LOAD_CALIBRATION'
; 12/27/2006 - Implemented dual table support
; 12/28/2006 - Implemented Get/Load GlobalConfigData. Added variable in global config to enable/disable dual ignition config support
; 12/28/2006 - Implemented Hysteresis on user defined outputs
; 12/30/2006 - Implemented special behavior for cranking-rpm advance (advance locks to cell 0,0)
; 04/05/2007 - Implemented noise filtering algorithm, tuneable using global configuration data
;************************************************


				XDEF Entry,main,TIMER_ROLL,TIMER0,DOPIP,SCI_TX_READY,SCI_RX_READY,ADC_DONE
				Include 'MC68HC908KX8.equ'

Version_major		equ		3				;Major Version Number
Version_minor		equ		2				;Minor Version Number
Version_bugfix		equ		1				;Bugfix Version Number

enableIRQ:			equ		%00000000		;enable hardware IRQ
maskIRQ:			equ		%00000010		;mask hardware IRQ
initCONFIG1: 		equ		%00001110     	;Init. for Low Power Consumption. Enable COP (Computer Operating Properly)
initCONFIG2: 		equ		%00001001	  	;Enable external oscillator input on PTB6
initStack:   		equ		RamLast       	;init. stack pointer to last RAM

SelectCH2AD_Int: 	equ		%01000010	  	;init ADSCR select and Read CH2, use Interrupt
SelectCH2AD_Poll:	equ		%00000010		;init ADSCR select CH2, use polling

initADICLK   		equ		%01010000     	;initial ADICLK = Bus/4, use bus frequency
Timerstop    		equ  	%00110010     	;Stop timer, reset of timer counter, prescale for 1 usec
Timergo      		equ 	%00000010     	;Enable timer, prescale of 4 for 1 usec increment, interrupts
SetPWM       		equ  	%00011010     	;PWM, clear on compare, toggle state on overflow
SetPWMNoTog  		equ  	%00011000     	;PWM, clear on compare, no toggle on overflow
SetOCInitH			equ  	%00000000     	; Clear output

SetSawTimer	 		equ		%01011000	  	;pwm; clear on compare; no toggle on overflow; interrupt enabled

RPM_BIN_UBOUND		equ		9				;the upper bound of the RPM bins
MAP_BIN_UBOUND		equ		9				;the upper bound of the MAP bins
LOAD_BINS			equ		10				;number of load bins
RPM_BINS			equ		10				;number of RPM bins


;*************************************************
;communication API constants
;*************************************************
;current command Modes
GetVersion			equ		1				;Retrieve MJLJ Version
GetState			equ		2				;Retrieve the current state
GetStateEx			equ		3				;Extended version of 'getState'
GetConfig	    	equ		4				;Retrieve Ignition Controller Configuration
SetConfig	    	equ		5				;Set the ignition Map Config
UpdateConfig		equ		6				;Update the Ignition Controller Configuration
UpdateCell			equ		7				;Update a cell in the ignition config
WriteFlash			equ		8				;write Ignition controller configuration to flash
ReadLoadADC			equ		9				;Read the raw ADC value from load - used for TPS calibration
UpdateLoadCal		equ		10				;Current command is updating the load table
GetLoadCal			equ		11				;Send the entire load calibration table to the client
GetGlobalConfig		equ		12				;Retrieve Global configuration values
UpdateGlobalConfig	equ		13				;Set Global configuration values
StopTransmit		equ		14				;stop Transmit command

;command lengths
GetVersionLength		equ		3				;data packet length of Get Version command
GetStateLength			equ		6				;data packet length of current runtime state
GetConfigLength			equ		128				;data packet length of ignition controller configuration
UpdateLoadCalSegmentLength 	equ		128				;data packet length of a load calibration segment (2 segments needed for full update)
GetLoadCalLength		equ		256				;data packet length of the entire load calibaration table
GlobalConfigLength		equ		64				;data packet length of the global config data

;*************************************************
;End communication API constants
;*************************************************

HysteresisThreshold	equ		1

DEFAULT_RAM SECTION SHORT    

;!!! Important! do not change order of data - the following needs to precede the next block of data!  see AN1831
MAPValue			ds      1				;value read from ADC
RPMValue			ds		1				;the actual RPM Value /100 (i.e. 5200 RPM = 52). in increments of 100 RPM
BelowIdleFlag		ds		1				;non zero indicates the engine is below idle (i.e. not running)
RPMCountHigh		ds		1				;RPM tick count high value
RPMCountLow			ds		1				;RPM tick count low value
AdvanceDegrees		ds		1				;current advance degrees

CurrentRPMBin		ds		1				;the selected RPM range bin offset
CurrentMAPBin		ds		1				;the selected MAP range bin offset

;!!! Important! do not change order of data - the following needs to start at RAM+$08!  see AN1831
CTRLBYT				ds		1				;Control byte for Flash programming routine
CPUSPD				ds		1				;CPU Speed flag
LADDR				ds		2				;last address for range program

;Ignition Configuration start-- Must start at RAM+$0C for proper Flash programming see AN1831
;!!! Important! do not change the order of this data!
CONFIG_DATA:
RPMBINS 			ds		10				;RPM bins- actual RPM value / 100 (i.e. 5200 RPM = 52). in increments of 100 RPM
MAPBINS				ds		10				;MAP bins- calculated MAP KPa values
IGNITION_MAP		ds		100				;10 x 10 map of ignition values, with actual ignition advance value- 0 to 59 degrees
CONFIG_CYLINDERS 	ds		1				;number of cylinders - 4,6 or 8

USER_OUTPUT_CONFIG	ds		1				;bits 7-4 indicate output type- 1 = RPM switch, 0 = MAP switch
											;bits 3-0 indicate output mode- 1 = "on" on exceed threshold, 0 = "off" on exceed threshold
											
USER_OUTPUT_1		ds		1				;user output switch 1 threshold value- either RPM value or MAP value, in the format of RPM/MAP bin values
USER_OUTPUT_2		ds		1				;user output switch 2 threshold value- either RPM value or MAP value, in the format of RPM/MAP bin values
USER_OUTPUT_3		ds		1				;user output switch 3 threshold value- either RPM value or MAP value, in the format of RPM/MAP bin values
USER_OUTPUT_4		ds		1				;user output switch 4 threshold value- either RPM value or MAP value, in the format of RPM/MAP bin values

REV_LIMITER			ds		1				;rev limiter output switch (contains RPM value in same format as in RPM Bins)
RPM_SHIFT_LIGHT		ds		1				;shift light output switch value (contains RPM value in same format as in RPM Bins)
;Ignition Configuration end

SAWActive			ds		1				;SAW signal is currently being processed
currentCommand		ds		1				;the current communication command that is active
cmdSendIndex		ds		1				;the current command index value when transmitting multiple bytes
											;i.e. tracks where we are during data transmit

interp_x1			ds		1				;interpolation X1 reference
interp_x2			ds		1				;interpolation X2 reference
interp_y1			ds		1				;interpolation Y1 reference
interp_y2			ds		1				;interpolation Y2 reference
interp_x			ds		1				;interpolation reference input
interp_y			ds		1				;interpolation result
interp_neg_slope	ds		1				;interpolation negative slope indicator

currentConfig		ds		1				;Indicates which ignition config is active - 0 or 1

updateCellBins		ds		1				;Saved Bins for single cell update routine
											;high 4 bits has RPM Bin; low 4 bits has Load Bin

DEFAULT_ROM		SECTION


;**************************************************************
;* Main_Init - This is the point where code starts executing  *
;*             after a RESET.                                 *
;**************************************************************
Entry:
main:
		sei									;disable interrupts during initialization
		rsp									;reset stack pointer
		clra
		clrx

		clra                 				;Init. Acc. For simulation
		mov    #initCONFIG1,CONFIG1 		;initialize Config1
		mov    #initCONFIG2,CONFIG2 		;initialize Config2

		mov		#maskIRQ,INTSCR				;disable IRQ		
		
		mov		#initADICLK,ADCLK			;initialize ADC clock prescalar

		ldhx   #initStack+1  				;initialize the stack pointer
		txs

		jsr		InitExtOsc					;initialize external osciallator
		jsr		InitSerial					;initialize serial i/o
		jsr		InitPorts					;initialize ports

		ldhx   #RamStart     				;point to start of RAM


ClearRAM:
		clr    ,x            				;clear RAM location
		aix    #1            				;advance pointer
		cphx   #RamLast+1    				;done ?
		bne    ClearRAM      				;loop back if not


		jsr		SET_ACTIVE_CONFIG_DATA		;select the ignition config we will be using
		jsr		UPDATE_RAM_CONFIG			;copy the saved configuration in flash to runtime location in RAM

		mov		#1,BelowIdleFlag			;we're below idle when we start up
		mov		#0,RPMValue
		mov		#100,MAPValue				;put 100KPa as the default MAP value before we do the first MAP conversion		
		mov		#0,AdvanceDegrees
		mov		#1,SawActive				;initialize the SAWActive flag
		mov		#0,currentConfig				;default to current config 0
				
        mov     #Timerstop,tsc        		;Stop Timer so it can be set up
		
		mov		#$FF,RPMCountHigh			;initialize RPM Count to minumum RPM value
		mov		#$FF,RPMCountLow			;initialize RPM Count to minimum RPM value

		jsr		UPDATE_USER_OUTPUTS			;initialize the user outputs
        cli									;enable interrupts

;***************************************************************************
; Main Loop
;***************************************************************************

MAIN_LOOP:
	    sta COPCTL		   			;service cop control register to prevent reset

;***************************************************************************
;check if the config_data option changed
;***************************************************************************
		lda		GLOBAL_ENABLE_DUAL_CONFIG	;are dual configs disabled?
		beq		CHECK_CONFIG_DONE			;if so skip the check
		
		brset 	7,PORTB, CHECK_CONFIG_1 ;branch according to how the option input is set
		
		lda 	currentConfig
		cmp 	#0
		bne 	SWITCH_CONFIG			;did the selected option change 0->1?
		bra		CHECK_CONFIG_DONE		
		
CHECK_CONFIG_1:
		lda		currentConfig
		cmp 	#1
		bne 	SWITCH_CONFIG			;did the selected option change 1->0?
		bra		CHECK_CONFIG_DONE
		
SWITCH_CONFIG:
		sei								;disable interrupts
		jsr		SET_ACTIVE_CONFIG_DATA	;verify selected config w/debounce
		jsr		UPDATE_RAM_CONFIG		;copy selected config data into RAM
		cli 							;re-enable interrupts 

CHECK_CONFIG_DONE:
				
    	lda	BelowIdleFlag
    	beq SKIP_BELOW_IDLE_PROCESSING

     	mov #SelectCH2AD_Int,ADSCR 		;Select channel2 PTA4, request ADC read

		ldx #0
BELOW_IDLE_DELAY_LOOP:
		decx
		bne BELOW_IDLE_DELAY_LOOP
		
SKIP_BELOW_IDLE_PROCESSING:

        

;***************************************************************************
; On the V3 board the PIP signal is inverted through the MAX232A- so 
; we poll for the start of the PIP pulse
;***************************************************************************


		bih	SAW_OK
		ldx PIP_NOISE_FILTER_LEVEL  ;load our saved filter level
SAW_NOISE_FILTER:					;filter out noisy spikes on the PIP line
		bih SAW_OK					;A-HA we detected it was a spike (within configured the threshold)
		beq SAW_NOISE_FILTER_PASS   ;passed the filter
		decx
		bra	SAW_NOISE_FILTER

SAW_NOISE_FILTER_PASS:		
		MOV #0,SawActive

		bra	END_SAW_PROCESS
SAW_OK:
		lda	SawActive
		cmp #0						;SAW is active; skip re-triggering
		bne END_SAW_PROCESS
		
		lda currentCommand			;are we processing a command that uses the config data in RAM?
		cmp #UpdateLoadCal			;if so we need to skip processing the SAW pulse
		beq END_SAW_PROCESS
		cmp #UpdateGlobalConfig     ;are we updating the global config data?
		beq END_SAW_PROCESS			;if so we need to skip processing the SAW pulse
		

;***************************************************************************
;***************************************************************************
;***************************************************************************
; Fire the SAW pulse
;***************************************************************************
;***************************************************************************
;***************************************************************************

		clrh
		sei
										
		lda		TCNTH					;save the current timer values as RPM count
		sta		RPMCountHigh
		lda 	TCNTL					 
		sta		RPMCountLow

		lda		RPMCountHigh			;check to see if the timer looped (i.e. below idle)
		bne		SET_ABOVE_IDLE
		lda		RPMCountLow
		bne		SET_ABOVE_IDLE
		bra		IDLE_CHECK_DONE
		
SET_ABOVE_IDLE:
		mov		#0,BelowIdleFlag		;we're above idle

IDLE_CHECK_DONE:

        lda     tsc        
        MOV     #Timerstop,tsc        	; Stop Timer so it can be set up
		

		clrh
		ldx		AdvanceDegrees			;load the advance degrees from the previous calculation. Advance calculation is delayed by 1 ignition event
										;due to processing load

		lda		ADVANCE_HIGHB, X		;extract the advance value from the pre-calculated table,
		sta		TCH0H					;store it in the timer channel 0 output compare
		lda		ADVANCE_LOWB, X
		sta		TCH0L

        mov     #SetOCInitH,TSC0		;clear and
       	mov		#SetSawTimer,TSC0       ;set up the timer

        MOV     #Timergo,TSC          	; set timer prescaler to divide by 4 and start the SAW pulse!


        mov		#1,SAWActive			;SAW pulse is now active

		cli								; re-enable interrupts

      	mov 	#SelectCH2AD_Int,ADSCR 		;Select channel2 PTA4, request ADC read
		
END_SAW_PROCESS:
		jmp MAIN_LOOP

;***************************************************************************
;***************************************************************************
;***************************************************************************
; PIP Command word receive - calculate some required values
;***************************************************************************
;***************************************************************************
;***************************************************************************
DOPIP:
		rti


;***************************************************************************
;***************************************************************************
;***************************************************************************
; Reads the 'option' (PTB7) port and determines which map to use
;***************************************************************************
;***************************************************************************
;***************************************************************************
SET_ACTIVE_CONFIG_DATA:

		lda		GLOBAL_ENABLE_DUAL_CONFIG		;check if dual configs are enabled
		bne		SET_ACTIVE_CONFIG_TRY_AGAIN
		mov		#0,currentConfig				;if disabled in global config, default to config 0
		bra 	SET_ACTIVE_CONFIG_DATA_DONE
		
SET_ACTIVE_CONFIG_TRY_AGAIN:

		brset  	7,PORTB,CONFIG_1_SELECTED  ;if the 'option' input is high, jump to CONFIG_1 debounce selection
		
CONFIG_0_SELECTED:

		ldx		#$FF
CONFIG_0_DEBOUNCE_DELAY:
		brset	7,PORTB,SET_ACTIVE_CONFIG_TRY_AGAIN  ;if the switch is still bouncing, then we try again.. must settle for a count of 256
		decx	
		bne		CONFIG_0_DEBOUNCE_DELAY
		mov		#0,currentConfig
		bra		SET_ACTIVE_CONFIG_DATA_DONE
CONFIG_1_SELECTED:

		ldx 	#$FF
CONFIG_1_DEBOUNCE_DELAY:
		brclr	7,PORTB,SET_ACTIVE_CONFIG_TRY_AGAIN ;if the switch is still bouncing, then we try again.. must settle for a count of 256
		decx
		bne		CONFIG_1_DEBOUNCE_DELAY
		mov		#1,currentConfig


SET_ACTIVE_CONFIG_DATA_DONE:

		rts
		
ADC_DONE:
;***************************************************************************
; Finished reading the MAP sensor through ADC channel 2
;***************************************************************************
		pshh

        lda    	ADR           			;Load A with Analog Data Register
        tax
        lda     LOAD_CALIBRATION,x		;Convert A/D read to Kilopascals
        sta		MAPValue				;Store the value for later use
		
		jsr		SET_RPM_VALUE			;set the actual RPM Value based the RPM Count High/Low value
		jsr		SET_ADVANCE_DEGREES		;get the current advance degrees
		bsr 	UPDATE_USER_OUTPUTS		;update the user outputs
		
		pulh
		rti
;***************************************************************************
; Process the user outputs
;***************************************************************************
UPDATE_USER_OUTPUTS:

;User output 1
		clrh

		brset	0,USER_OUTPUT_CONFIG,TYPE_RPM_1
		lda		MAPValue
		bra		CHECK_VALUE_1
TYPE_RPM_1:
		lda		RPMValue
CHECK_VALUE_1:
		psha
		lda		USER_OUTPUT_1
		cmp		1,sp
		bhi		USER_OUTPUT_1_OFF
				
		brset	4,USER_OUTPUT_CONFIG,USER_OUTPUT_1_HIGH ;test for mode configuration 1=high, 0=low
		bra		USER_OUTPUT_1_LOW

USER_OUTPUT_1_OFF:
		brclr	4,USER_OUTPUT_CONFIG,USER_OUTPUT_INVERT_HYSTERESIS_1
		brclr	0,PORTA,SKIP_HYSTERESIS_1
		bra		USER_OUTPUT_ADJUST_HYSTERESIS_1
USER_OUTPUT_INVERT_HYSTERESIS_1:
		brset	0,PORTA,SKIP_HYSTERESIS_1
USER_OUTPUT_ADJUST_HYSTERESIS_1:
		sub		#HysteresisThreshold
		cmp		1,sp
		bhi		SKIP_HYSTERESIS_1
		bra		USER_OUTPUT_1_DONE
SKIP_HYSTERESIS_1:

		brset	4,USER_OUTPUT_CONFIG,USER_OUTPUT_1_LOW
USER_OUTPUT_1_HIGH:
		bset	0,PORTA
		bra		USER_OUTPUT_1_DONE
USER_OUTPUT_1_LOW:
		bclr	0,PORTA

USER_OUTPUT_1_DONE:
		pula



;User Output 2
		brset	1,USER_OUTPUT_CONFIG,TYPE_RPM_2
		lda		MAPValue
		bra		CHECK_VALUE_2
TYPE_RPM_2:
		lda		RPMValue
CHECK_VALUE_2:
		psha
		lda		USER_OUTPUT_2
		cmp		1,sp
		bhi		USER_OUTPUT_2_OFF
				
		brset	5,USER_OUTPUT_CONFIG,USER_OUTPUT_2_HIGH ;test for mode configuration 1=high, 0=low
		bra		USER_OUTPUT_2_LOW

USER_OUTPUT_2_OFF:
		brclr	5,USER_OUTPUT_CONFIG,USER_OUTPUT_INVERT_HYSTERESIS_2
		brclr	1,PORTA,SKIP_HYSTERESIS_2
		bra		USER_OUTPUT_ADJUST_HYSTERESIS_2
USER_OUTPUT_INVERT_HYSTERESIS_2:
		brset	1,PORTA,SKIP_HYSTERESIS_2
USER_OUTPUT_ADJUST_HYSTERESIS_2:
		sub		#HysteresisThreshold
		cmp		1,sp
		bhi		SKIP_HYSTERESIS_2
		bra		USER_OUTPUT_2_DONE
SKIP_HYSTERESIS_2:

		brset	5,USER_OUTPUT_CONFIG,USER_OUTPUT_2_LOW
USER_OUTPUT_2_HIGH:
		bset	1,PORTA
		bra		USER_OUTPUT_2_DONE
USER_OUTPUT_2_LOW:
		bclr	1,PORTA

USER_OUTPUT_2_DONE:
		pula

;User Output 3
		brset	2,USER_OUTPUT_CONFIG,TYPE_RPM_3
		lda		MAPValue
		bra		CHECK_VALUE_3
TYPE_RPM_3:
		lda		RPMValue
CHECK_VALUE_3:
		psha
		lda		USER_OUTPUT_3
		cmp		1,sp
		bhi		USER_OUTPUT_3_OFF
				
		brset	6,USER_OUTPUT_CONFIG,USER_OUTPUT_3_HIGH ;test for mode configuration 1=high, 0=low
		bra		USER_OUTPUT_3_LOW

USER_OUTPUT_3_OFF:
		brclr	6,USER_OUTPUT_CONFIG,USER_OUTPUT_INVERT_HYSTERESIS_3
		brclr	3,PORTA,SKIP_HYSTERESIS_3
		bra		USER_OUTPUT_ADJUST_HYSTERESIS_3
USER_OUTPUT_INVERT_HYSTERESIS_3:
		brset	3,PORTA,SKIP_HYSTERESIS_3
USER_OUTPUT_ADJUST_HYSTERESIS_3:
		sub		#HysteresisThreshold
		cmp		1,sp
		bhi		SKIP_HYSTERESIS_3
		bra		USER_OUTPUT_3_DONE
SKIP_HYSTERESIS_3:

		brset	6,USER_OUTPUT_CONFIG,USER_OUTPUT_3_LOW
USER_OUTPUT_3_HIGH:
		bset	3,PORTA
		bra		USER_OUTPUT_3_DONE
USER_OUTPUT_3_LOW:
		bclr	3,PORTA

USER_OUTPUT_3_DONE:
		pula




;User Output 4
		brset	3,USER_OUTPUT_CONFIG,TYPE_RPM_4
		lda		MAPValue
		bra		CHECK_VALUE_4
TYPE_RPM_4:
		lda		RPMValue
CHECK_VALUE_4:
		psha
		lda		USER_OUTPUT_4
		cmp		1,sp
		bhi		USER_OUTPUT_4_OFF
				
		brset	7,USER_OUTPUT_CONFIG,USER_OUTPUT_4_HIGH ;test for mode configuration 1=high, 0=low
		bra		USER_OUTPUT_4_LOW

USER_OUTPUT_4_OFF:
		brclr	7,USER_OUTPUT_CONFIG,USER_OUTPUT_INVERT_HYSTERESIS_4
		brclr	4,PORTA,SKIP_HYSTERESIS_4
		bra		USER_OUTPUT_ADJUST_HYSTERESIS_4
USER_OUTPUT_INVERT_HYSTERESIS_4:
		brset	4,PORTA,SKIP_HYSTERESIS_4
USER_OUTPUT_ADJUST_HYSTERESIS_4:
		sub		#HysteresisThreshold
		cmp		1,sp
		bhi		SKIP_HYSTERESIS_4
		bra		USER_OUTPUT_4_DONE
SKIP_HYSTERESIS_4:

		brset	7,USER_OUTPUT_CONFIG,USER_OUTPUT_4_LOW
USER_OUTPUT_4_HIGH:
		bset	4,PORTA
		bra		USER_OUTPUT_4_DONE
USER_OUTPUT_4_LOW:
		bclr	4,PORTA

USER_OUTPUT_4_DONE:
		pula
		
;shift Light RPM switch
PROCESS_SHIFT_LIGHT:
		lda		RPM_SHIFT_LIGHT
		cmp		RPMValue
		bhi		SHIFT_LIGHT_OFF
SHIFT_LIGHT_ON:
		bset	1,PORTB
		bra		PROCESS_SHIFT_LIGHT_DONE
SHIFT_LIGHT_OFF:
		brclr	1,PORTB,SKIP_SHIFT_LIGHT_HYSTERESIS
		sub		#HysteresisThreshold
		cmp		RPMValue
		bhi		SKIP_SHIFT_LIGHT_HYSTERESIS
		bra		PROCESS_SHIFT_LIGHT_DONE
SKIP_SHIFT_LIGHT_HYSTERESIS:
		bclr	1,PORTB
PROCESS_SHIFT_LIGHT_DONE:


;Rev limiting process
PROCESS_REV_LIMIT:
		lda		REV_LIMITER
		cmp		RPMValue
		bhi		REV_LIMIT_OFF
REV_LIMIT_ON:
		bset	0,PORTB		
		bra		PROCESS_REV_LIMIT_DONE
REV_LIMIT_OFF:		
		brclr	0,PORTB,SKIP_REV_LIMIT_HYSTERESIS
		sub		#HysteresisThreshold
		cmp		RPMValue
		bhi		SKIP_REV_LIMIT_HYSTERESIS
		bra		PROCESS_REV_LIMIT_DONE
SKIP_REV_LIMIT_HYSTERESIS:
		bclr	0,PORTB		
PROCESS_REV_LIMIT_DONE:

		rts

;***************************************************************************
; Copy saved ignition config to RAM
;***************************************************************************
UPDATE_RAM_CONFIG:

		clrh
		lda		currentConfig
		bne		UPDATE_RAM_CONFIG_1
		

UPDATE_RAM_CONFIG_0:
		ldx		#128
UPDATE_RAM_CONTINUE_0:
		decx
		lda		SAVED_CONFIG_DATA_0,x
		sta		CONFIG_DATA,x
		cpx		#0
		bne		UPDATE_RAM_CONTINUE_0
		bra		UPDATE_RAM_CONFIG_DONE
		
UPDATE_RAM_CONFIG_1:
		ldx		#128
UPDATE_RAM_CONTINUE_1:
		decx
		lda		SAVED_CONFIG_DATA_1,x
		sta		CONFIG_DATA,x
		cpx		#0
		bne		UPDATE_RAM_CONTINUE_1

UPDATE_RAM_CONFIG_DONE:
		rts



;*********************************************************
;*********************************************************
; Handle communications - Send buffer is empty, ready for
; next byte
;*********************************************************
;*********************************************************
SCI_TX_READY:
		sta		COPCTL
		pshh

		lda		SCS1					;clear the SCRF bit

		lda		currentCommand
		cmp		#GetState				;continue processing the GetState command
		bne		SCI_TX_NEXT1		
		jsr		PROCESS_GET_STATE
		bra		DONE_TX

SCI_TX_NEXT1:
		cmp		#GetConfig				;continue processing the GetConfig command
		bne		SCI_TX_NEXT2
		jsr		PROCESS_GET_CONFIG
		bra		DONE_TX

SCI_TX_NEXT2:
		cmp		#GetVersion				;continue processing the GetVersion command
		bne		SCI_TX_NEXT3
		jsr		PROCESS_GET_VERSION
		bra		DONE_TX

SCI_TX_NEXT3:							;continue processing the Read Load ADC command
		cmp 	#ReadLoadADC
		bne		SCI_TX_NEXT4
		jsr		PROCESS_GET_RAW_ADC
		bra		DONE_TX
	
SCI_TX_NEXT4:
		cmp		#GetLoadCal				;continue processing the Get Load Calibration command
		bne		SCI_TX_NEXT5
		jsr		PROCESS_GET_LOAD_CAL
		bra		DONE_TX
		
SCI_TX_NEXT5:
		cmp		#GetGlobalConfig
		bne		SCI_TX_NEXT6
		jsr		PROCESS_GET_GLOBAL_CONFIG
		bra		DONE_TX
		
SCI_TX_NEXT6:
		cmp		#StopTransmit
		bne		SCI_TX_NEXT7
        bclr    TE,SCC2                 ; Disable Transmit
        bclr    SCTIE,SCC2              ; Disable transmit interrupt		
        clr		currentCommand			; finished with this command
		bra		DONE_TX
		
SCI_TX_NEXT7:
		cmp		#GetStateEx				;continue processing the GetState command
		bne		SCI_TX_NEXT8		
		jsr		PROCESS_GET_STATE_EX
		bra		DONE_TX

SCI_TX_NEXT8:
DONE_TX:		
		pulh
		STA		COPCTL
		rti



		
;***************************************************************************
; Process get state
; Processes the transmit of the current ignition state
;***************************************************************************
PROCESS_GET_STATE:
		
		lda		cmdSendIndex
		cmp		#$00					;send ignition advance
		bne		STATE_VALUE_1
		lda		AdvanceDegrees
		bra		STATE_SEND_VALUE
		
STATE_VALUE_1:
		cmp		#$01
		bne		STATE_VALUE_2
		lda		RPMCountHigh			;send the RPM count high byte
		bra		STATE_SEND_VALUE
		
STATE_VALUE_2:
		cmp		#$02
		bne		STATE_VALUE_3
		lda		RPMCountLow				;send the RPM count low byte
		bra		STATE_SEND_VALUE
		
STATE_VALUE_3:
		cmp		#$03
		bne		STATE_VALUE_4
		lda		CurrentRPMBin			;send the current RPM Bin
		bra		STATE_SEND_VALUE
		
STATE_VALUE_4:
		cmp		#$04
		bne		STATE_VALUE_5
		lda		CurrentMAPBin			;send the current MAP bin
		bra		STATE_SEND_VALUE

STATE_VALUE_5:
		cmp		#$05
		bne		STATE_TERMINATE
		lda		MAPValue
		bra		STATE_SEND_VALUE
		
STATE_TERMINATE:
        bclr    TE,SCC2                 ; Disable Transmit
        bclr    SCTIE,SCC2              ; Disable transmit interrupt
        clr		currentCommand			; finished with this command		
		bra		DONE_PROCESS_GET_STATE

STATE_SEND_VALUE:
		sta		SCDR
		inc		cmdSendIndex

DONE_PROCESS_GET_STATE:
		rts



;***************************************************************************
; Process get state - extended version
; Processes the transmit of the current ignition state
;***************************************************************************
PROCESS_GET_STATE_EX:
		
		lda		cmdSendIndex
		cmp		#$00					;send ignition advance
		bne		STATE_VALUE_1_EX
		lda		AdvanceDegrees
		bra		STATE_SEND_VALUE_EX
		
STATE_VALUE_1_EX:
		cmp		#$01
		bne		STATE_VALUE_2_EX
		lda		RPMCountHigh			;send the RPM count high byte
		bra		STATE_SEND_VALUE_EX
		
STATE_VALUE_2_EX:
		cmp		#$02
		bne		STATE_VALUE_3_EX
		lda		RPMCountLow				;send the RPM count low byte
		bra		STATE_SEND_VALUE_EX
		
STATE_VALUE_3_EX:
		cmp		#$03
		bne		STATE_VALUE_4_EX
		lda		CurrentRPMBin			;send the current RPM Bin
		lsla							;shift the RPMBin bits to the upper 4 bits
		lsla
		lsla
		lsla
		add		CurrentMAPBin
		bra		STATE_SEND_VALUE_EX
		
STATE_VALUE_4_EX:						;send the MAP value
		cmp		#$04
		bne		STATE_VALUE_5_EX
		lda		MAPValue
		bra		STATE_SEND_VALUE_EX

STATE_VALUE_5_EX:						
		;send the active configured outputs
		;the following code produces this packet
		;indicating the various controller states
		;-----------------------------------------
		; CFG| (reserved)| SL| RL| 4 | 3 | 2 | 1 |
		;-----------------------------------------
		cmp		#$05
		bne		STATE_TERMINATE_EX
		lda		#0
		brclr	0,PORTA,STATE_OUTPUT_1_DONE
		add		#1
STATE_OUTPUT_1_DONE:

		brclr	1,PORTA,STATE_OUTPUT_2_DONE
		add		#2		
STATE_OUTPUT_2_DONE:

		brclr	3,PORTA,STATE_OUTPUT_3_DONE
		add		#4
STATE_OUTPUT_3_DONE:

		brclr	4,PORTA,STATE_OUTPUT_4_DONE
		add		#8
STATE_OUTPUT_4_DONE:

		brclr	0,PORTB,STATE_REV_LIMIT_DONE
		add		#16
STATE_REV_LIMIT_DONE:

		brclr	1,PORTB,STATE_SHIFT_LIGHT_DONE
		add		#32
STATE_SHIFT_LIGHT_DONE:

		ldx		currentConfig
		beq     STATE_CURRENT_CONFIG_DONE
		add		#128
STATE_CURRENT_CONFIG_DONE:

		bra		STATE_SEND_VALUE_EX
		
STATE_TERMINATE_EX:
        bclr    TE,SCC2                 ; Disable Transmit
        bclr    SCTIE,SCC2              ; Disable transmit interrupt
        clr		currentCommand			; finished with this command		
		bra		DONE_PROCESS_GET_STATE_EX

STATE_SEND_VALUE_EX:
		sta		SCDR
		inc		cmdSendIndex

DONE_PROCESS_GET_STATE_EX:
		rts



;***************************************************************************
; Process get config
; Processes the transmit of the current configuration
;***************************************************************************


PROCESS_GET_CONFIG:
		
		lda		cmdSendIndex
		cmp		#GetConfigLength		;are we at the end?
		blo		SEND_NEXT_CONFIG_BYTE
        bclr    TE,SCC2                 ; Disable Transmit
        bclr    SCTIE,SCC2              ; Disable transmit interrupt		
        clr		currentCommand			; finished with this command
        BRA		DONE_PROCESS_GET_CONFIG
SEND_NEXT_CONFIG_BYTE:
		tax
		lda		CONFIG_DATA,x			;load a config data value from memory
		sta		SCDR					;send it out the serial port
		inc		cmdSendIndex			;increment for the next byte
				     
        
DONE_PROCESS_GET_CONFIG:        
		rts


;***************************************************************************
; Process Get Version
;***************************************************************************
PROCESS_GET_VERSION:
		lda		cmdSendIndex
		cmp		#$00
		bne		GET_VERSION_VALUE_2
		lda		#Version_major
		bra		PROCESS_GET_VERSION_SEND_VALUE
GET_VERSION_VALUE_2
		cmp		#$01
		bne		GET_VERSION_VALUE_3
		lda		#Version_minor
		bra		PROCESS_GET_VERSION_SEND_VALUE
GET_VERSION_VALUE_3
		cmp		#$02
		bne		GET_VERSION_DONE
		lda		#Version_bugfix
		bra		PROCESS_GET_VERSION_SEND_VALUE
GET_VERSION_DONE
        bclr    TE,SCC2                 ; Disable Transmit
        bclr    SCTIE,SCC2              ; Disable transmit interrupt
        clr		currentCommand			; finished with this command		
		bra		PROCESS_GET_VERSION_DONE
		
PROCESS_GET_VERSION_SEND_VALUE:
		sta		SCDR
		inc		cmdSendIndex
		
PROCESS_GET_VERSION_DONE:
		rts
		
		
		
;***************************************************************************
; Process Get Raw ADC Value
;***************************************************************************
PROCESS_GET_RAW_ADC:

		lda		cmdSendIndex
		cmp		#$00
		bne		DONE_GET_RAW_ADC
		sei										;disable all interrupts		
       	mov    	#SelectCH2AD_Poll,ADSCR 		;Select channel2 PTA4
ADC_READ_WAIT:
        brclr  	7,ADSCR,ADC_READ_WAIT 			;Wait till read is complete

        lda    	ADR           					;Load A with Analog Data Register
        sta		scdr							;send back the raw value
        cli										;enable interrupts
        inc		cmdSendIndex
        bra		EXIT_GET_RAW_ADC				;done for now

DONE_GET_RAW_ADC:								;all done sending raw ADC value
        bclr    TE,SCC2                 		;Disable Transmit
        bclr    SCTIE,SCC2              		;Disable transmit interrupt		
        clr		currentCommand					;Finished with this command

EXIT_GET_RAW_ADC:        
		rts


;***************************************************************************
; Process Get load calibration table
;***************************************************************************
PROCESS_GET_LOAD_CAL:
		
		ldx		cmdSendIndex
		lda		LOAD_CALIBRATION,x
		sta		SCDR
		inc		cmdSendIndex
		cpx		#GetLoadCalLength - 1
		bne		DONE_PROCESS_GET_LOAD_CAL
										;since we're using an 8bit index to send 256 bytes of data,
										;we can't stop the transmitter in the 'next' interrupt.
										;we create a special command to stop the transmitter.
		mov		#StopTransmit, currentCommand
		
DONE_PROCESS_GET_LOAD_CAL:        
		rts

;***************************************************************************
; Process Get Global Configuration Data
;***************************************************************************
PROCESS_GET_GLOBAL_CONFIG:
		ldx		cmdSendIndex
		lda		GLOBAL_CONFIG_DATA,x
		sta		SCDR
		inc		cmdSendIndex
		cpx		#GlobalConfigLength - 1
		bne		DONE_PROCESS_GET_GLOBAL_CONFIG
		
		mov		#StopTransmit, currentCommand

DONE_PROCESS_GET_GLOBAL_CONFIG:        
		rts



		
;*********************************************************
;*********************************************************
; Handle communications - Buffer has character available
;*********************************************************
;*********************************************************
SCI_RX_READY:
		sta		COPCTL
		pshh
		
		lda		SCS1					;Clear the SCRF Bit
		
		lda		currentCommand			;get the current command
		
		cmp		#UpdateConfig			;are we in the middle of receiving a config update?
		bne		CHECK_UPDATE_CELL
		jsr		PROCESS_UPDATE_CONFIG
		jmp		DONE_RX
		
CHECK_UPDATE_CELL:						
		cmp		#UpdateCell				;are we in the middle of an Update Cell command?
		bne		CHECK_UPDATE_LOAD_CALIBRATION
		jsr		PROCESS_UPDATE_CELL		
		jmp		DONE_RX
		
CHECK_UPDATE_LOAD_CALIBRATION:
		cmp		#UpdateLoadCal			;are we in the middle of an update load calibration command?
		bne		CHECK_UPDATE_GLOBAL_CONFIG
		jsr		PROCESS_UPDATE_LOAD_CALIBRATION
		jmp		DONE_RX

CHECK_UPDATE_GLOBAL_CONFIG:
		cmp		#UpdateGlobalConfig
		bne		CHECK_ACTIVE_COMMAND
		jsr		PROCESS_UPDATE_GLOBAL_CONFIG
		jmp		DONE_RX

CHECK_ACTIVE_COMMAND:
		cmp		#0						;are there any commands active?
		beq		CHECK_COMMAND_VALUE		;if any commands are still active then we cannot process another command
		lda		SCDR					;grab the data and throw it away...
		jmp		DONE_RX
				
CHECK_COMMAND_VALUE:
		clr		cmdSendIndex			;reset the send index value		
		lda 	SCDR					;load the command value
		
		cmp		#83						;character 'S'
		beq		MODE_GET_STATE			;get the current state

		cmp		#36						;character '$'
		beq		MODE_GET_STATE_EX		;extended version of 'get state'
										
		cmp		#67						;character 'C'
		beq		MODE_GET_CONFIG			;get the current config
		
		cmp		#85						;character 'U'
		beq		MODE_UPDATE_CONFIG		;Update Configuration
		
		cmp		#117					;character 'u' (lower case U)
		beq		MODE_UPDATE_CELL		;Update only 1 cell
		
		cmp		#87						;character 'W'
		beq		MODE_WRITE_FLASH		;Write Flash
		
		cmp		#86						;character 'V'
		beq		MODE_GET_VERSION		;get MJLJ version
		
		cmp		#97						;character 'a' 
		beq		MODE_GET_RAW_ADC		;read raw load ADC value, used for load calibration
	
		cmp		#76						;character 'L'
		beq		MODE_UPDATE_LOAD_CALIBRATION	;update load calibration table
		
		cmp		#108					;character 'l'
		beq		MODE_GET_LOAD_CALIBRATION ;send the load calibration table
		
		cmp 	#71						;character 'G'
		beq		MODE_UPDATE_GLOBAL_CONFIG ;Update the global configuration data
		
		cmp		#103					;character 'g'
		beq		MODE_GET_GLOBAL_CONFIG	;send the global configuration data
										
		jmp		DONE_RX					;unknown command. ignore

		
MODE_GET_VERSION:
		mov		#GetVersion, currentCommand ;We're processing the 'GetVersion' command
		bra		START_SEND
		
MODE_GET_STATE:
		mov		#GetState,currentCommand		;We're processing the 'GetState' command
		bra		START_SEND		

MODE_GET_STATE_EX:
		mov		#GetStateEx,currentCommand		;We're processing the 'GetStateEx' command
		bra		START_SEND
		
MODE_GET_CONFIG:
		mov		#GetConfig,currentCommand		;we're processing the 'GetConfig' command
		bra		START_SEND						

MODE_UPDATE_CONFIG:								
		MOV		#UpdateConfig,currentCommand	;we're processing the 'UpdateConfig' command
		bra		DONE_RX							;we're expecting more data to follow... don't enable transmit interrupt
		
MODE_UPDATE_CELL:
		mov		#UpdateCell, currentCommand		;we're processing the 'UpdateCell' command - update just one advance value
		bra		DONE_RX							;we're expecting more data to follow... don't enable transmit
		
MODE_WRITE_FLASH:
		mov		#WriteFlash,currentCommand		;We're requesting the ignition config to be persisted in flash
		clr		cmdSendIndex
		bsr		WRITE_FLASH_CONFIG
		clr		currentCommand
		bra		DONE_RX
		
MODE_GET_RAW_ADC:								;send the raw ADC value back
		mov		#ReadLoadADC,currentCommand
		bra		START_SEND

MODE_UPDATE_LOAD_CALIBRATION:
		mov		#UpdateLoadCal, currentCommand 	;We're processing the 'Load Calibration' command
		bra		DONE_RX							;more data to follow... don't enable transmit

MODE_GET_LOAD_CALIBRATION:						;send back the load calibration table
		mov		#GetLoadCal,currentCommand
		bra		START_SEND

MODE_UPDATE_GLOBAL_CONFIG:						
		mov		#UpdateGlobalConfig,currentCommand	;update the global config data
		bra		DONE_RX

MODE_GET_GLOBAL_CONFIG:
		mov		#GetGlobalConfig,currentCommand
		bra		START_SEND
				
START_SEND:
		bset	TE,SCC2						; Enable transmit
		bset	SCTIE,SCC2					; Enable transmit interrupt

DONE_RX:
		pulh
		sta		COPCTL
		rti

;***************************************************************************
; Write configuration to flash
;***************************************************************************
	
WRITE_FLASH_CONFIG:							
		
		sei									;disable all interrupts
		
		lda		currentConfig
		bne		WRITE_FLASH_CONFIG_1
		
WRITE_FLASH_CONFIG_0:
		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#SAVED_CONFIG_DATA_0			; starting address of data in flash
		jsr 	ERARNGE 						; erase the 64 byte page starting at SAVED_CONFIG_DATA_0

		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#SAVED_CONFIG_DATA_0 + 64		; starting address of data in flash
		jsr 	ERARNGE 						; erase the 64 byte page starting at SAVED_CONFIG_DATA_ + 64 bytes

		ldhx	#SAVED_CONFIG_DATA_END_0 - 1	; program config data_0
		STHX	LADDR
		MOV		#16,CPUSPD
		ldhx	#SAVED_CONFIG_DATA_0
	    JSR 	PRGRNGE		
		bra		DONE_WRITE_FLASH_CONFIG
WRITE_FLASH_CONFIG_1:
		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#SAVED_CONFIG_DATA_1			; starting address of data in flash
		jsr 	ERARNGE 						; erase the 64 byte page starting at SAVED_CONFIG_DATA_1

		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#SAVED_CONFIG_DATA_1 + 64		; starting address of data in flash
		jsr 	ERARNGE 						; erase the 64 byte page starting at SAVED_CONFIG_DATA_1 + 64 bytes

		ldhx	#SAVED_CONFIG_DATA_END_1 - 1	; program config data
		STHX	LADDR
		MOV		#16,CPUSPD
		ldhx	#SAVED_CONFIG_DATA_1
	    JSR 	PRGRNGE		

DONE_WRITE_FLASH_CONFIG:											
       	cli									;enable interrupts
		rts

;***************************************************************************
; Process Update Load Calibration
;***************************************************************************	
PROCESS_UPDATE_LOAD_CALIBRATION:

		
UPDATE_LOAD_CAL_PHASE1:						;we have 256 bytes to update and only 128 bytes to work with in RAM.
											; we will do it in two steps, flashing the data in-between
											
		lda		cmdSendIndex
		cmp		#128
		blo		SKIP_LOAD_CAL_PHASE2_ADJUST
		sub		#128
SKIP_LOAD_CAL_PHASE2_ADJUST:
		tax
		
		lda		SCDR
		sta		CONFIG_DATA,X
		inc		cmdSendIndex
		cpx		#UpdateLoadCalSegmentLength - 1
		blo		DONE_PROCESS_UPDATE_LOAD_CALIBRATION
		
		lda		cmdSendIndex				; OK, we're flashing either the first part or second.
		cmp		#UpdateLoadCalSegmentLength
		bne		DO_FLASH_LOAD_CAL_2			; go flash the second.
DO_FLASH_LOAD_CAL_1:

		sei									;disable all interrupts
		
		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#LOAD_CALIBRATION					; starting address of data in flash
		jsr 	ERARNGE 					; erase the 64 byte page starting at SAVED_CONFIG_DATA


		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#LOAD_CALIBRATION + 64				; starting address of data in flash
		jsr 	ERARNGE 					; erase the 64 byte page starting at SAVED_CONFIG_DATA + 64 bytes

		ldhx	#LOAD_CALIBRATION_END - 128 - 1	; program config data
		STHX	LADDR
		MOV		#16,CPUSPD
		ldhx	#LOAD_CALIBRATION
	    JSR 	PRGRNGE		
        											
       	cli									;enable interrupts

		bra		DONE_PROCESS_UPDATE_LOAD_CALIBRATION
DO_FLASH_LOAD_CAL_2:

		sei									;disable all interrupts
				
		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#LOAD_CALIBRATION + 128			; starting address of data in flash
		jsr 	ERARNGE 					; erase the 64 byte page starting at the referenced location


		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#LOAD_CALIBRATION + 64	+ 128		; starting address of data in flash
		jsr 	ERARNGE 					; erase the next 64 byte page

		ldhx	#LOAD_CALIBRATION_END-  1			; program config data
		STHX	LADDR
		MOV		#16,CPUSPD
		ldhx	#LOAD_CALIBRATION + 128
	    JSR 	PRGRNGE		

		jsr		UPDATE_RAM_CONFIG			;restore the ignition config
		clr		currentCommand				;all done with data transfer

       	cli									;enable interrupts
		
DONE_PROCESS_UPDATE_LOAD_CALIBRATION:
		rts

		
PROCESS_UPDATE_GLOBAL_CONFIG:

		ldx		cmdSendIndex
		lda		SCDR
		sta		CONFIG_DATA,X
		inc 	cmdSendIndex
		cpx		#GlobalConfigLength - 1
		blo		DONE_PROCESS_UPDATE_GLOBAL_CONFIG

		;done with transferring data- 
		;flash the global config data		
		sei

		mov 	#16,CPUSPD
		bclr 	MASSBIT,CTRLBYT
		LDHX 	#GLOBAL_CONFIG_DATA			; starting address of data in flash
		jsr 	ERARNGE 					; erase the 64 byte page starting at GLOBAL_CONFIG_DATA

		ldhx	#GLOBAL_CONFIG_DATA_END - 1	; program config data
		STHX	LADDR
		MOV		#16,CPUSPD
		ldhx	#GLOBAL_CONFIG_DATA
	    JSR 	PRGRNGE		
		
		jsr		UPDATE_RAM_CONFIG			;restore the configuration data
		clr		currentCommand				;all done with this command
		
		cli
DONE_PROCESS_UPDATE_GLOBAL_CONFIG:
		rts


;***************************************************************************
; Process update configuration
;***************************************************************************
PROCESS_UPDATE_CONFIG:


		ldx		cmdSendIndex
		lda     SCDR
		sta		CONFIG_DATA,x
		inc		cmdSendIndex
		cpx		#GetConfigLength - 1
		bne		DONE_PROCESS_UPDATE_CONFIG
		clr		currentCommand

DONE_PROCESS_UPDATE_CONFIG:
		rts

;***************************************************************************
; Process Update Ignition Cell
;***************************************************************************	
PROCESS_UPDATE_CELL:
		lda 	cmdSendIndex
		cmp		#0
		bne		UPDATE_ADVANCE_VALUE		;first byte has the RPM bin
		lda		SCDR
		sta		updateCellBins
		inc		cmdSendIndex
		bra		DONE_PROCESS_UPDATE_CELL
				
UPDATE_ADVANCE_VALUE:						;ready to update the ignition value
		lda		updateCellBins				;find the location in the MAP to update
		and		#$0F
		tax
		lda		#LOAD_BINS					;index to memory offset (loadBin * 10) + rpmBin
		mul
		psha
		lda		updateCellBins
		and		#$f0
		lsra
		lsra
		lsra
		lsra
		add		1,sp
		tax
		lda		SCDR						;the next byte contains the ignition value
		sta		IGNITION_MAP,X
		clr		currentCommand				;all done with the current command
		pula
		
DONE_PROCESS_UPDATE_CELL:		
		rts


		
				
;***************************************************************************
; Initialize External Oscillator
;***************************************************************************
InitExtOsc:	 							;use when config2 = %001010X0
										;or config2 = %001110X0
										;or config2 = %000010X0
		lda 	#$13
oscWait:
		sta		COPCTL					; service COP register while waiting
								 		; turn on both ICG & ECG
								 		
		sta 	icgcr 
		cmpa	icgcr
		bne		oscWait

		rts

;***************************************************************************
; Initialize Ports
;***************************************************************************
InitPorts:

		bset	0,DDRA			;PTA0 as output 
		bclr	0,PORTA			;Programmable output 1

		bset	1,DDRA			;PTA1 as output
		bclr	1,PORTA			;Porgrammable output 2

		bset	3,DDRA			;PTA3 as output
		bclr	3,PORTA			;Programmable output 3
		
		bset	4,DDRA			;PTA4 as output
		bclr	4,PORTA			;Programmable output 4
		
		bset	0,DDRB			;PTB0 as output
		bclr	0,PORTB			;Rev Limit output
		
		bset	1,DDRB			;PTB1 as output
		bclr	1,PORTB			;Shift Light output
		
		bclr	7,DDRB			;PTB6 as input
		
		rts


;***************************************************************************
; Initialize SPI interface
;***************************************************************************
InitSerial:

		mov   #%00110000,SCBR       ; Baud Rate = 4800 - highest conventional baud rate using
									; a 16MHz clock input
									
		bset	ENSCI,SCC1		; Enable SCI
		bset	RE,SCC2			; Enable receiver
        bset    SCRIE,SCC2      ; Enable Receive interrupt
		lda		SCS1			; Clear SCI transmitter Empty Bit
			
		rts

;***************************************************************************
; SET_RPM_VALUE
;
; Looks up the RPM Value variable based on the RPMCountHigh and RPMCountLow values
; The RPM value is actual RPM/100 (i.e. 5200 RPM = 52) in increments of 100 RPM
; value is stored in variable RPMValue
;***************************************************************************
SET_RPM_VALUE:

		lda		BelowIdleFlag
		cmp		#1
		beq		ZERO_RPM
		
		ldhx	#96						;go backwards through the table starting at 10,000 RPM
		
		lda		CONFIG_CYLINDERS
		cmp		#4						;4 cylinder?
		beq		NEXT_RPM_TICK_4
		cmp		#6
		beq		NEXT_RPM_TICK_6
		bra		NEXT_RPM_TICK_8
				
NEXT_RPM_TICK_4:
		decx	
		beq		ZERO_RPM
		
		lda		RPM_TICKS_HIGH_4,X
		cmp		RPMCountHigh
		blo		NEXT_RPM_TICK_4
		bhi		RPM_VALUE_FOUND
		lda		RPM_TICKS_LOW_4,X
		cmp		RPMCountLow
		blo		NEXT_RPM_TICK_4
		bra		RPM_VALUE_FOUND

NEXT_RPM_TICK_6:
		decx
		beq		ZERO_RPM
		
		lda		RPM_TICKS_HIGH_6,X
		cmp		RPMCountHigh
		blo		NEXT_RPM_TICK_6
		bhi		RPM_VALUE_FOUND
		lda		RPM_TICKS_LOW_6,X
		cmp		RPMCountLow
		blo		NEXT_RPM_TICK_6
		bra		RPM_VALUE_FOUND
		
NEXT_RPM_TICK_8:
		decx
		beq		ZERO_RPM
		
		lda		RPM_TICKS_HIGH_8,X
		cmp		RPMCountHigh
		blo		NEXT_RPM_TICK_8
		bhi		RPM_VALUE_FOUND
		lda		RPM_TICKS_LOW_8,X
		cmp		RPMCountLow
		blo		NEXT_RPM_TICK_8
		bra		RPM_VALUE_FOUND
		
RPM_VALUE_FOUND:

		txa
		add		#5						;offset it back for starting at 500 RPM
		sta		RPMValue	
		rts
ZERO_RPM:
		mov		#0,RPMValue				;RPM is officially zero
		rts


		

;***************************************************************************
; SET_ADVANCE_DEGREES
;
; Looks up the correct ignition advance value from the ignition table
; based on the target RPM and MAP value.
; See the "PROGRAMMABLE DATA AREA" section below for more information.
;***************************************************************************
SET_ADVANCE_DEGREES:
		
		lda		BelowIdleFlag			;Are we at cranking RPM; i.e. 'below idle' ?
		beq		ABOVE_IDLE
		mov		#0,CurrentRPMBin		;If so implement special behavior- use ignition advance at 0,0
		mov		#0,CurrentMAPBin
		lda		IGNITION_MAP			;load first value in ignition map (0,0)
		sta		AdvanceDegrees
		rts

ABOVE_IDLE:
		lda		REV_LIMITER				;first do soft Rev limit check.
		deca							;Soft rev limit is REV_LIMITER-1 (Rev limit RPM - 100 RPM)
		cmp		RPMValue
		bhi		NO_SOFT_REV_LIMIT		
		mov		#0,AdvanceDegrees		;set advance to zero, soft rev limit enabled
		rts
		
NO_SOFT_REV_LIMIT:						;And continue...				
		ldhx 	#0						;Figure out what RPM bin to use.
TEST_RPM_BIN:							
		lda		RPMBINS,X				;walk through the RPM bins until we find the one that matches
		cmp		RPMValue
		bls		NEXT_RPM_BIN
		txa
		cmp		#0						;did we match to the first map bin?
		beq		USING_FIRST_RPM_BIN
		deca							;back up to the last one- that's the target
USING_FIRST_RPM_BIN:
		sta		CurrentRPMBin
		bra		FIND_RPM_BIN_DONE
NEXT_RPM_BIN:
		txa
		cmp		#RPM_BIN_UBOUND			;we use the last one if we've run out of MAP bins
		bhs		USE_LAST_RPM_BIN
		incx
		bra		TEST_RPM_BIN
USE_LAST_RPM_BIN:
		mov		#RPM_BIN_UBOUND,CurrentRPMBin
FIND_RPM_BIN_DONE:		

FIND_MAP_BIN:							;Determine what MAP bin to use.
		ldhx	#0
TEST_MAP_BIN:
		lda		MAPBINS,X				;walk through the MAP bins until we find the one that matches.
		cmp		MAPValue
		bls		NEXT_MAP_BIN
		txa
		cmp		#0						;did we match to the first MAP bin?
		beq		USING_FIRST_MAP_BIN
		deca							;back up to the last one- that's the target.
USING_FIRST_MAP_BIN:
		sta		CurrentMAPBin
		bra		FIND_MAP_BIN_DONE
NEXT_MAP_BIN:
		txa
		cmp		#MAP_BIN_UBOUND 		;we stay with the last one if we've run out of MAP bins.
		bhs		USE_LAST_MAP_BIN
		incx
		bra		TEST_MAP_BIN
USE_LAST_MAP_BIN:
		mov		#MAP_BIN_UBOUND,CurrentMAPBin
FIND_MAP_BIN_DONE:

;-----------------------------------------------------
; start the interpolation process. in order to calculate the interpolated
; ignition advance, we'll be working with 4 ignition advance values
; somewhere within the ignition table, based on the CurrentMAPBin and the CurrentRPMBin.
; The CurrentMAPBin and CurrentRPMBin correspond to the upper left hand corner of the example
; listed below:
;
;                                            R P M  A X I S
;  -----------------------------------------------------------------------------------------
;M |
;A |                        ----------------------------------------
;P |                        | MAP-LOW_RPM-LOW   | MAP-LOW_RPM_HIGH |
;  |                        |--------------------------------------|
;A |                        | MAP-HIGH_RPM-LOW  | MAP-HIGH_RPM_HIGH|
;X |                        ----------------------------------------
;I |
;S |
;  -----------------------------------------------------------------------------------------
;
; steps:
;
; 1. interpolate ignition advance between MAP-LOW_RPM-LOW and MAP-LOW_RPM_HIGH and save the result
; 2. interoplate ignition advance between MAP-HIGH_RPM-LOW and MAP-HIGH_RPM_HIGH and save the result
; 3. interpolate between the values generated from step 1 and 2 using the CurrentMAPValue for scaling
;    and store that as the final interpolated value
;

; perform Step 1

;fetch the MAP-LOW_RPM-LOW ignition advance value

		ldx		CurrentRPMBin			;parameters
		lda		CurrentMAPBin			;parameters
		bsr		GET_DEGREE_VALUE		;ignition advance degree result in accumulator
		sta		interp_y1
		
;fetch the MAP-LOW_RPM-HIGH ignition advance value
										
		lda		#1						;indicate the next RPM Bin, if available
		bsr		GET_ADJACENT_RPM_BIN	;result in Accumulator
		tax								;switch to X as parameter
		lda		CurrentMAPBin			;parameter
		bsr		GET_DEGREE_VALUE		;ignition advance degree result in accumulator
		sta		interp_y2		
		
		
		ldx		CurrentRPMBin			;fetch the X1, X2 reference values (RPM bin values)
		lda		RPMBINS,X
		sta		interp_x1
		
		lda		#1
		bsr		GET_ADJACENT_RPM_BIN	;get the next RPM BIN, if available
		tax
		lda		RPMBINS,X
		sta		interp_x2
		
		lda		RPMValue				;Actual RPM/100 
		sta		interp_x
		bsr		LININTERP				;all ready to go, do the linear interpolation
		lda		interp_y				;this is the result
		psha							;save it for later
		
;perform step 2

;fetch the MAP-HIGH_RPM-LOW ignition advance value
		lda		#1						;indicate next MAP Bin, if available
		bsr		GET_ADJACENT_MAP_BIN	;result in Accumulator
		ldx		CurrentRPMBin			;parameters
		bsr		GET_DEGREE_VALUE		;ignition advance degree result in accumulator
		sta		interp_y1
		
;fetch the MAP-HIGH_RPM-HIGH ignition advance value
		lda		#1						;indicate the next RPM bin, if available
		bsr		GET_ADJACENT_RPM_BIN	;result in Accumulator
		psha							;save it for later
		lda		#1						;indicate the next MAP bin, if available
		bsr		GET_ADJACENT_MAP_BIN	;result in Accumulator, input to parameter
		pulx							;pull back RPM Bin, input to parameter
		bsr		GET_DEGREE_VALUE		;ignition advance degree result in accumulator
		sta		interp_y2
		
		bsr		LININTERP				;all ready to go, do the linear interpolation
										;note that interp_X1 and interp_X2 do not need to change
		lda		interp_y

;perform step 3
		sta		interp_y2				;save result as the input to the next interpolation process

		pula	
		sta		interp_y1				;save step 1 result as the input to the next interpolation process
		
		ldx		CurrentMAPBin			;get the MAP value for the CurrentMAPBin
		lda		MAPBINS,X
		sta		interp_x1
		
		lda		#1						;get the MAP Bin value for the next MAP Bin, if available
		bsr		GET_ADJACENT_MAP_BIN
		tax
		lda		MAPBINS,X
		sta		interp_x2
		
		lda		MAPValue				;store the current MAP value as input to interpolation
		sta		interp_x
		
		bsr		LININTERP				;last interpolation call
		lda		interp_y		
		sta		AdvanceDegrees			;store it as the current advance degrees

		rts

		
;***************************************************************
;** look up the target ignition advance value, based on the 
;** specified MAP bin and RPM bin
;
;** Parameters:
;** Accumulator has MAP Bin
;** X has RPM Bin
;** returns result in accumulator		
;***************************************************************
GET_DEGREE_VALUE:						
		
		pshx							;save the RPM Bin value
		ldhx	#RPM_BIN_UBOUND+1		;Y-axis map bin target * the RPM bin size
		mul								;skip down to the appropriate MAP Bin row in the ingition map
		
		add		1,SP					;add the RPM bin that was put on the Stack pointer
										;to index across the RPM (X axis) to the final target
		tax
		lda		IGNITION_MAP,X			;extract the igntion value
		
		pulx							;clean up
		rts								;result left in accumulator

;***************************************************************
;** find an adjacent RPM_BIN, if available. Returns CurrentRPMBin+X, if the RPMBin
;** isn't railed. if so, it just returns CurrentRPMBin
;**
;** Depends on CurrentRPMBin
;** Accumulator holds offset. e.g. 0 = returns CurrentRPMBin , 1=returns CurrentRPMBin+1, etc.
;** Target RPM Bin returned in accumulator
;***************************************************************
GET_ADJACENT_RPM_BIN:
		add		CurrentRPMBin
		cmp		#RPM_BIN_UBOUND
		bhs		CURRENT_RPM_BIN_RAILED
		rts
CURRENT_RPM_BIN_RAILED:
		lda		CurrentRPMBin
		rts
		
;***************************************************************
;** find an adjacent MAP_BIN, if available. Returns CurrentMAPBin+X, if the MAP Bin
;** isn't railed. if so, it returns CurrentMAPBin
;**
;** Depends on CurrentMAPBin
;** Accumulator holds offset. e.g. 0 = returns CurrentMAPBin , 1=returns  CurrentMAPBin+1, etc.
;** Target MAP Bin returned in accumulator
;***************************************************************
GET_ADJACENT_MAP_BIN:
		add		CurrentMAPBin
		cmp		#MAP_BIN_UBOUND
		bhs		CURRENT_MAP_BIN_RAILED
		rts
CURRENT_MAP_BIN_RAILED:
		lda		CurrentMAPBin
		rts


;***************************************************************************
;**
;** Linear Interpolation - 2D
;**
;**            (y2 - y1)
;**  y = y1 +  --------- * (x - x1)
;**            (x2 - x1)
;**
;**   interp_x1 = x1	(input low reference)
;**   interp_x2 = x2    (input high reference)
;**   interp_y1 = y1	(target low reference)
;**   interp_y2 = y2	(target high reference)
;**   interp_x = x		(input reference value)
;**   interp_y = y		(target interpolated result stored here)
;**	  interp_neg_slope (negative slope indicator)
;***************************************************************************
LININTERP:
        clr     interp_neg_slope    ; This is the negative slope detection bit
        mov     interp_y1,interp_y
CHECK_LESS_THAN:
        lda     interp_x
        cmp     interp_x1
        bhi     CHECK_GREATER_THAN
        bra     DONE_WITH_INTERP
CHECK_GREATER_THAN:
        lda     interp_x
        cmp     interp_x2
        blo     DO_INTERP
        mov     interp_y2,interp_y
        bra     DONE_WITH_INTERP

DO_INTERP:
        mov     interp_y1,interp_y
        lda     interp_x2
        sub     interp_x1
        beq     DONE_WITH_INTERP
        psha
        lda     interp_y2
        sub     interp_y1
	bcc	POSINTERP
        nega
        inc     interp_neg_slope
POSINTERP:
        psha
        lda     interp_x
        sub     interp_x1
        beq     ZERO_SLOPE
        pulx
        mul
        pshx
        pulh
        pulx

        div

        psha
        lda     interp_neg_slope
        bne     NEG_SLOPE
        pula
        add     interp_y1
        sta     interp_y
        bra     DONE_WITH_INTERP
NEG_SLOPE:
        pula
        sta     interp_neg_slope
        lda     interp_y1
        sub     interp_neg_slope
        sta     interp_y
        bra     DONE_WITH_INTERP
ZERO_SLOPE:
        pula            ;clean stack
        pula            ;clean stack
DONE_WITH_INTERP:
        rts


	
TIMER_ROLL:
		rti

        
TIMER0:
		pshh

		bclr	CH0F,TSC0
		
		lda		SAWActive
		cmp		#1
		beq		RESET_TIMER
	    mov		#0,RPMValue				;RPM is officially zero
        MOV     #Timerstop,tsc        	; Stop Timer
		mov		#1,BelowIdleFlag		;we're above idle
  		bra		TIMER0_EXIT
RESET_TIMER:							;SAW signal is finished- adjust registers so TIMER0
										;interrupt overflows at full value ($FFFF)
		mov		#2,SAWActive
		lda		#0
		sta		TCH0H
		sta		TCH0L					;reset timer channel registers to full value	
		mov		#Timergo,tsc			;resume the timer
			
TIMER0_EXIT:
		pulh
		rti
	
	
;*********************************************
;STATIC CONFIGURATION DATA
;*********************************************

;RPM tick count lookup, 4 Cylinder
RPM_TICKS_HIGH_4:
	DC.B	$EA		;500RPM High Byte, 4 cylinder
	DC.B	$C3		;600RPM High Byte, 4 cylinder
	DC.B	$A7		;700RPM High Byte, 4 cylinder
	DC.B	$92		;800RPM High Byte, 4 cylinder
	DC.B	$82		;900RPM High Byte, 4 cylinder
	DC.B	$75		;1000RPM High Byte, 4 cylinder
	DC.B	$6A		;1100RPM High Byte, 4 cylinder
	DC.B	$61		;1200RPM High Byte, 4 cylinder
	DC.B	$5A		;1300RPM High Byte, 4 cylinder
	DC.B	$53		;1400RPM High Byte, 4 cylinder
	DC.B	$4E		;1500RPM High Byte, 4 cylinder
	DC.B	$49		;1600RPM High Byte, 4 cylinder
	DC.B	$44		;1700RPM High Byte, 4 cylinder
	DC.B	$41		;1800RPM High Byte, 4 cylinder
	DC.B	$3D		;1900RPM High Byte, 4 cylinder
	DC.B	$3A		;2000RPM High Byte, 4 cylinder
	DC.B	$37		;2100RPM High Byte, 4 cylinder
	DC.B	$35		;2200RPM High Byte, 4 cylinder
	DC.B	$32		;2300RPM High Byte, 4 cylinder
	DC.B	$30		;2400RPM High Byte, 4 cylinder
	DC.B	$2E		;2500RPM High Byte, 4 cylinder
	DC.B	$2D		;2600RPM High Byte, 4 cylinder
	DC.B	$2B		;2700RPM High Byte, 4 cylinder
	DC.B	$29		;2800RPM High Byte, 4 cylinder
	DC.B	$28		;2900RPM High Byte, 4 cylinder
	DC.B	$27		;3000RPM High Byte, 4 cylinder
	DC.B	$25		;3100RPM High Byte, 4 cylinder
	DC.B	$24		;3200RPM High Byte, 4 cylinder
	DC.B	$23		;3300RPM High Byte, 4 cylinder
	DC.B	$22		;3400RPM High Byte, 4 cylinder
	DC.B	$21		;3500RPM High Byte, 4 cylinder
	DC.B	$20		;3600RPM High Byte, 4 cylinder
	DC.B	$1F		;3700RPM High Byte, 4 cylinder
	DC.B	$1E		;3800RPM High Byte, 4 cylinder
	DC.B	$1E		;3900RPM High Byte, 4 cylinder
	DC.B	$1D		;4000RPM High Byte, 4 cylinder
	DC.B	$1C		;4100RPM High Byte, 4 cylinder
	DC.B	$1B		;4200RPM High Byte, 4 cylinder
	DC.B	$1B		;4300RPM High Byte, 4 cylinder
	DC.B	$1A		;4400RPM High Byte, 4 cylinder
	DC.B	$1A		;4500RPM High Byte, 4 cylinder
	DC.B	$19		;4600RPM High Byte, 4 cylinder
	DC.B	$18		;4700RPM High Byte, 4 cylinder
	DC.B	$18		;4800RPM High Byte, 4 cylinder
	DC.B	$17		;4900RPM High Byte, 4 cylinder
	DC.B	$17		;5000RPM High Byte, 4 cylinder
	DC.B	$16		;5100RPM High Byte, 4 cylinder
	DC.B	$16		;5200RPM High Byte, 4 cylinder
	DC.B	$16		;5300RPM High Byte, 4 cylinder
	DC.B	$15		;5400RPM High Byte, 4 cylinder
	DC.B	$15		;5500RPM High Byte, 4 cylinder
	DC.B	$14		;5600RPM High Byte, 4 cylinder
	DC.B	$14		;5700RPM High Byte, 4 cylinder
	DC.B	$14		;5800RPM High Byte, 4 cylinder
	DC.B	$13		;5900RPM High Byte, 4 cylinder
	DC.B	$13		;6000RPM High Byte, 4 cylinder
	DC.B	$13		;6100RPM High Byte, 4 cylinder
	DC.B	$12		;6200RPM High Byte, 4 cylinder
	DC.B	$12		;6300RPM High Byte, 4 cylinder
	DC.B	$12		;6400RPM High Byte, 4 cylinder
	DC.B	$12		;6500RPM High Byte, 4 cylinder
	DC.B	$11		;6600RPM High Byte, 4 cylinder
	DC.B	$11		;6700RPM High Byte, 4 cylinder
	DC.B	$11		;6800RPM High Byte, 4 cylinder
	DC.B	$10		;6900RPM High Byte, 4 cylinder
	DC.B	$10		;7000RPM High Byte, 4 cylinder
	DC.B	$10		;7100RPM High Byte, 4 cylinder
	DC.B	$10		;7200RPM High Byte, 4 cylinder
	DC.B	$10		;7300RPM High Byte, 4 cylinder
	DC.B	$0F		;7400RPM High Byte, 4 cylinder
	DC.B	$0F		;7500RPM High Byte, 4 cylinder
	DC.B	$0F		;7600RPM High Byte, 4 cylinder
	DC.B	$0F		;7700RPM High Byte, 4 cylinder
	DC.B	$0F		;7800RPM High Byte, 4 cylinder
	DC.B	$0E		;7900RPM High Byte, 4 cylinder
	DC.B	$0E		;8000RPM High Byte, 4 cylinder
	DC.B	$0E		;8100RPM High Byte, 4 cylinder
	DC.B	$0E		;8200RPM High Byte, 4 cylinder
	DC.B	$0E		;8300RPM High Byte, 4 cylinder
	DC.B	$0D		;8400RPM High Byte, 4 cylinder
	DC.B	$0D		;8500RPM High Byte, 4 cylinder
	DC.B	$0D		;8600RPM High Byte, 4 cylinder
	DC.B	$0D		;8700RPM High Byte, 4 cylinder
	DC.B	$0D		;8800RPM High Byte, 4 cylinder
	DC.B	$0D		;8900RPM High Byte, 4 cylinder
	DC.B	$0D		;9000RPM High Byte, 4 cylinder
	DC.B	$0C		;9100RPM High Byte, 4 cylinder
	DC.B	$0C		;9200RPM High Byte, 4 cylinder
	DC.B	$0C		;9300RPM High Byte, 4 cylinder
	DC.B	$0C		;9400RPM High Byte, 4 cylinder
	DC.B	$0C		;9500RPM High Byte, 4 cylinder
	DC.B	$0C		;9600RPM High Byte, 4 cylinder
	DC.B	$0C		;9700RPM High Byte, 4 cylinder
	DC.B	$0B		;9800RPM High Byte, 4 cylinder
	DC.B	$0B		;9900RPM High Byte, 4 cylinder
	DC.B	$0B		;10000RPM High Byte, 4 cylinder
		
RPM_TICKS_LOW_4:
	DC.B	$60		;500RPM Low Byte, 4 cylinder
	DC.B	$50		;600RPM Low Byte, 4 cylinder
	DC.B	$69		;700RPM Low Byte, 4 cylinder
	DC.B	$7C		;800RPM Low Byte, 4 cylinder
	DC.B	$35		;900RPM Low Byte, 4 cylinder
	DC.B	$30		;1000RPM Low Byte, 4 cylinder
	DC.B	$89		;1100RPM Low Byte, 4 cylinder
	DC.B	$A8		;1200RPM Low Byte, 4 cylinder
	DC.B	$25		;1300RPM Low Byte, 4 cylinder
	DC.B	$B5		;1400RPM Low Byte, 4 cylinder
	DC.B	$20		;1500RPM Low Byte, 4 cylinder
	DC.B	$3E		;1600RPM Low Byte, 4 cylinder
	DC.B	$EF		;1700RPM Low Byte, 4 cylinder
	DC.B	$1B		;1800RPM Low Byte, 4 cylinder
	DC.B	$AD		;1900RPM Low Byte, 4 cylinder
	DC.B	$98		;2000RPM Low Byte, 4 cylinder
	DC.B	$CE		;2100RPM Low Byte, 4 cylinder
	DC.B	$44		;2200RPM Low Byte, 4 cylinder
	DC.B	$F3		;2300RPM Low Byte, 4 cylinder
	DC.B	$D4		;2400RPM Low Byte, 4 cylinder
	DC.B	$E0		;2500RPM Low Byte, 4 cylinder
	DC.B	$12		;2600RPM Low Byte, 4 cylinder
	DC.B	$67		;2700RPM Low Byte, 4 cylinder
	DC.B	$DA		;2800RPM Low Byte, 4 cylinder
	DC.B	$69		;2900RPM Low Byte, 4 cylinder
	DC.B	$10		;3000RPM Low Byte, 4 cylinder
	DC.B	$CD		;3100RPM Low Byte, 4 cylinder
	DC.B	$9F		;3200RPM Low Byte, 4 cylinder
	DC.B	$83		;3300RPM Low Byte, 4 cylinder
	DC.B	$78		;3400RPM Low Byte, 4 cylinder
	DC.B	$7B		;3500RPM Low Byte, 4 cylinder
	DC.B	$8D		;3600RPM Low Byte, 4 cylinder
	DC.B	$AC		;3700RPM Low Byte, 4 cylinder
	DC.B	$D7		;3800RPM Low Byte, 4 cylinder
	DC.B	$0C		;3900RPM Low Byte, 4 cylinder
	DC.B	$4C		;4000RPM Low Byte, 4 cylinder
	DC.B	$95		;4100RPM Low Byte, 4 cylinder
	DC.B	$E7		;4200RPM Low Byte, 4 cylinder
	DC.B	$41		;4300RPM Low Byte, 4 cylinder
	DC.B	$A2		;4400RPM Low Byte, 4 cylinder
	DC.B	$0B		;4500RPM Low Byte, 4 cylinder
	DC.B	$7A		;4600RPM Low Byte, 4 cylinder
	DC.B	$EF		;4700RPM Low Byte, 4 cylinder
	DC.B	$6A		;4800RPM Low Byte, 4 cylinder
	DC.B	$EA		;4900RPM Low Byte, 4 cylinder
	DC.B	$70		;5000RPM Low Byte, 4 cylinder
	DC.B	$FA		;5100RPM Low Byte, 4 cylinder
	DC.B	$89		;5200RPM Low Byte, 4 cylinder
	DC.B	$1C		;5300RPM Low Byte, 4 cylinder
	DC.B	$B4		;5400RPM Low Byte, 4 cylinder
	DC.B	$4F		;5500RPM Low Byte, 4 cylinder
	DC.B	$ED		;5600RPM Low Byte, 4 cylinder
	DC.B	$8F		;5700RPM Low Byte, 4 cylinder
	DC.B	$34		;5800RPM Low Byte, 4 cylinder
	DC.B	$DD		;5900RPM Low Byte, 4 cylinder
	DC.B	$88		;6000RPM Low Byte, 4 cylinder
	DC.B	$36		;6100RPM Low Byte, 4 cylinder
	DC.B	$E7		;6200RPM Low Byte, 4 cylinder
	DC.B	$9A		;6300RPM Low Byte, 4 cylinder
	DC.B	$50		;6400RPM Low Byte, 4 cylinder
	DC.B	$07		;6500RPM Low Byte, 4 cylinder
	DC.B	$C1		;6600RPM Low Byte, 4 cylinder
	DC.B	$7E		;6700RPM Low Byte, 4 cylinder
	DC.B	$3C		;6800RPM Low Byte, 4 cylinder
	DC.B	$FC		;6900RPM Low Byte, 4 cylinder
	DC.B	$BE		;7000RPM Low Byte, 4 cylinder
	DC.B	$81		;7100RPM Low Byte, 4 cylinder
	DC.B	$47		;7200RPM Low Byte, 4 cylinder
	DC.B	$0E		;7300RPM Low Byte, 4 cylinder
	DC.B	$D6		;7400RPM Low Byte, 4 cylinder
	DC.B	$A0		;7500RPM Low Byte, 4 cylinder
	DC.B	$6B		;7600RPM Low Byte, 4 cylinder
	DC.B	$38		;7700RPM Low Byte, 4 cylinder
	DC.B	$06		;7800RPM Low Byte, 4 cylinder
	DC.B	$D5		;7900RPM Low Byte, 4 cylinder
	DC.B	$A6		;8000RPM Low Byte, 4 cylinder
	DC.B	$78		;8100RPM Low Byte, 4 cylinder
	DC.B	$4B		;8200RPM Low Byte, 4 cylinder
	DC.B	$1E		;8300RPM Low Byte, 4 cylinder
	DC.B	$F3		;8400RPM Low Byte, 4 cylinder
	DC.B	$C9		;8500RPM Low Byte, 4 cylinder
	DC.B	$A0		;8600RPM Low Byte, 4 cylinder
	DC.B	$78		;8700RPM Low Byte, 4 cylinder
	DC.B	$51		;8800RPM Low Byte, 4 cylinder
	DC.B	$2B		;8900RPM Low Byte, 4 cylinder
	DC.B	$05		;9000RPM Low Byte, 4 cylinder
	DC.B	$E1		;9100RPM Low Byte, 4 cylinder
	DC.B	$BD		;9200RPM Low Byte, 4 cylinder
	DC.B	$9A		;9300RPM Low Byte, 4 cylinder
	DC.B	$77		;9400RPM Low Byte, 4 cylinder
	DC.B	$56		;9500RPM Low Byte, 4 cylinder
	DC.B	$35		;9600RPM Low Byte, 4 cylinder
	DC.B	$15		;9700RPM Low Byte, 4 cylinder
	DC.B	$F5		;9800RPM Low Byte, 4 cylinder
	DC.B	$D6		;9900RPM Low Byte, 4 cylinder
	DC.B	$B8		;10000RPM Low Byte, 4 cylinder	
	
;RPM tick count lookup, 6 Cylinder	
RPM_TICKS_HIGH_6:
	DC.B	$9C		;500RPM High Byte, 6 cylinder
	DC.B	$82		;600RPM High Byte, 6 cylinder
	DC.B	$6F		;700RPM High Byte, 6 cylinder
	DC.B	$61		;800RPM High Byte, 6 cylinder
	DC.B	$56		;900RPM High Byte, 6 cylinder
	DC.B	$4E		;1000RPM High Byte, 6 cylinder
	DC.B	$47		;1100RPM High Byte, 6 cylinder
	DC.B	$41		;1200RPM High Byte, 6 cylinder
	DC.B	$3C		;1300RPM High Byte, 6 cylinder
	DC.B	$37		;1400RPM High Byte, 6 cylinder
	DC.B	$34		;1500RPM High Byte, 6 cylinder
	DC.B	$30		;1600RPM High Byte, 6 cylinder
	DC.B	$2D		;1700RPM High Byte, 6 cylinder
	DC.B	$2B		;1800RPM High Byte, 6 cylinder
	DC.B	$29		;1900RPM High Byte, 6 cylinder
	DC.B	$27		;2000RPM High Byte, 6 cylinder
	DC.B	$25		;2100RPM High Byte, 6 cylinder
	DC.B	$23		;2200RPM High Byte, 6 cylinder
	DC.B	$21		;2300RPM High Byte, 6 cylinder
	DC.B	$20		;2400RPM High Byte, 6 cylinder
	DC.B	$1F		;2500RPM High Byte, 6 cylinder
	DC.B	$1E		;2600RPM High Byte, 6 cylinder
	DC.B	$1C		;2700RPM High Byte, 6 cylinder
	DC.B	$1B		;2800RPM High Byte, 6 cylinder
	DC.B	$1A		;2900RPM High Byte, 6 cylinder
	DC.B	$1A		;3000RPM High Byte, 6 cylinder
	DC.B	$19		;3100RPM High Byte, 6 cylinder
	DC.B	$18		;3200RPM High Byte, 6 cylinder
	DC.B	$17		;3300RPM High Byte, 6 cylinder
	DC.B	$16		;3400RPM High Byte, 6 cylinder
	DC.B	$16		;3500RPM High Byte, 6 cylinder
	DC.B	$15		;3600RPM High Byte, 6 cylinder
	DC.B	$15		;3700RPM High Byte, 6 cylinder
	DC.B	$14		;3800RPM High Byte, 6 cylinder
	DC.B	$14		;3900RPM High Byte, 6 cylinder
	DC.B	$13		;4000RPM High Byte, 6 cylinder
	DC.B	$13		;4100RPM High Byte, 6 cylinder
	DC.B	$12		;4200RPM High Byte, 6 cylinder
	DC.B	$12		;4300RPM High Byte, 6 cylinder
	DC.B	$11		;4400RPM High Byte, 6 cylinder
	DC.B	$11		;4500RPM High Byte, 6 cylinder
	DC.B	$10		;4600RPM High Byte, 6 cylinder
	DC.B	$10		;4700RPM High Byte, 6 cylinder
	DC.B	$10		;4800RPM High Byte, 6 cylinder
	DC.B	$0F		;4900RPM High Byte, 6 cylinder
	DC.B	$0F		;5000RPM High Byte, 6 cylinder
	DC.B	$0F		;5100RPM High Byte, 6 cylinder
	DC.B	$0F		;5200RPM High Byte, 6 cylinder
	DC.B	$0E		;5300RPM High Byte, 6 cylinder
	DC.B	$0E		;5400RPM High Byte, 6 cylinder
	DC.B	$0E		;5500RPM High Byte, 6 cylinder
	DC.B	$0D		;5600RPM High Byte, 6 cylinder
	DC.B	$0D		;5700RPM High Byte, 6 cylinder
	DC.B	$0D		;5800RPM High Byte, 6 cylinder
	DC.B	$0D		;5900RPM High Byte, 6 cylinder
	DC.B	$0D		;6000RPM High Byte, 6 cylinder
	DC.B	$0C		;6100RPM High Byte, 6 cylinder
	DC.B	$0C		;6200RPM High Byte, 6 cylinder
	DC.B	$0C		;6300RPM High Byte, 6 cylinder
	DC.B	$0C		;6400RPM High Byte, 6 cylinder
	DC.B	$0C		;6500RPM High Byte, 6 cylinder
	DC.B	$0B		;6600RPM High Byte, 6 cylinder
	DC.B	$0B		;6700RPM High Byte, 6 cylinder
	DC.B	$0B		;6800RPM High Byte, 6 cylinder
	DC.B	$0B		;6900RPM High Byte, 6 cylinder
	DC.B	$0B		;7000RPM High Byte, 6 cylinder
	DC.B	$0B		;7100RPM High Byte, 6 cylinder
	DC.B	$0A		;7200RPM High Byte, 6 cylinder
	DC.B	$0A		;7300RPM High Byte, 6 cylinder
	DC.B	$0A		;7400RPM High Byte, 6 cylinder
	DC.B	$0A		;7500RPM High Byte, 6 cylinder
	DC.B	$0A		;7600RPM High Byte, 6 cylinder
	DC.B	$0A		;7700RPM High Byte, 6 cylinder
	DC.B	$0A		;7800RPM High Byte, 6 cylinder
	DC.B	$09		;7900RPM High Byte, 6 cylinder
	DC.B	$09		;8000RPM High Byte, 6 cylinder
	DC.B	$09		;8100RPM High Byte, 6 cylinder
	DC.B	$09		;8200RPM High Byte, 6 cylinder
	DC.B	$09		;8300RPM High Byte, 6 cylinder
	DC.B	$09		;8400RPM High Byte, 6 cylinder
	DC.B	$09		;8500RPM High Byte, 6 cylinder
	DC.B	$09		;8600RPM High Byte, 6 cylinder
	DC.B	$08		;8700RPM High Byte, 6 cylinder
	DC.B	$08		;8800RPM High Byte, 6 cylinder
	DC.B	$08		;8900RPM High Byte, 6 cylinder
	DC.B	$08		;9000RPM High Byte, 6 cylinder
	DC.B	$08		;9100RPM High Byte, 6 cylinder
	DC.B	$08		;9200RPM High Byte, 6 cylinder
	DC.B	$08		;9300RPM High Byte, 6 cylinder
	DC.B	$08		;9400RPM High Byte, 6 cylinder
	DC.B	$08		;9500RPM High Byte, 6 cylinder
	DC.B	$08		;9600RPM High Byte, 6 cylinder
	DC.B	$08		;9700RPM High Byte, 6 cylinder
	DC.B	$07		;9800RPM High Byte, 6 cylinder
	DC.B	$07		;9900RPM High Byte, 6 cylinder
	DC.B	$07		;10000RPM High Byte, 6 cylinder
		
RPM_TICKS_LOW_6:
	DC.B	$40		;500RPM Low Byte, 6 cylinder
	DC.B	$35		;600RPM Low Byte, 6 cylinder
	DC.B	$9B		;700RPM Low Byte, 6 cylinder
	DC.B	$A8		;800RPM Low Byte, 6 cylinder
	DC.B	$CE		;900RPM Low Byte, 6 cylinder
	DC.B	$20		;1000RPM Low Byte, 6 cylinder
	DC.B	$06		;1100RPM Low Byte, 6 cylinder
	DC.B	$1B		;1200RPM Low Byte, 6 cylinder
	DC.B	$19		;1300RPM Low Byte, 6 cylinder
	DC.B	$CE		;1400RPM Low Byte, 6 cylinder
	DC.B	$15		;1500RPM Low Byte, 6 cylinder
	DC.B	$D4		;1600RPM Low Byte, 6 cylinder
	DC.B	$F5		;1700RPM Low Byte, 6 cylinder
	DC.B	$67		;1800RPM Low Byte, 6 cylinder
	DC.B	$1E		;1900RPM Low Byte, 6 cylinder
	DC.B	$10		;2000RPM Low Byte, 6 cylinder
	DC.B	$34		;2100RPM Low Byte, 6 cylinder
	DC.B	$83		;2200RPM Low Byte, 6 cylinder
	DC.B	$F8		;2300RPM Low Byte, 6 cylinder
	DC.B	$8D		;2400RPM Low Byte, 6 cylinder
	DC.B	$40		;2500RPM Low Byte, 6 cylinder
	DC.B	$0C		;2600RPM Low Byte, 6 cylinder
	DC.B	$EF		;2700RPM Low Byte, 6 cylinder
	DC.B	$E7		;2800RPM Low Byte, 6 cylinder
	DC.B	$F1		;2900RPM Low Byte, 6 cylinder
	DC.B	$0B		;3000RPM Low Byte, 6 cylinder
	DC.B	$34		;3100RPM Low Byte, 6 cylinder
	DC.B	$6A		;3200RPM Low Byte, 6 cylinder
	DC.B	$AD		;3300RPM Low Byte, 6 cylinder
	DC.B	$FA		;3400RPM Low Byte, 6 cylinder
	DC.B	$52		;3500RPM Low Byte, 6 cylinder
	DC.B	$B4		;3600RPM Low Byte, 6 cylinder
	DC.B	$1D		;3700RPM Low Byte, 6 cylinder
	DC.B	$8F		;3800RPM Low Byte, 6 cylinder
	DC.B	$08		;3900RPM Low Byte, 6 cylinder
	DC.B	$88		;4000RPM Low Byte, 6 cylinder
	DC.B	$0E		;4100RPM Low Byte, 6 cylinder
	DC.B	$9A		;4200RPM Low Byte, 6 cylinder
	DC.B	$2B		;4300RPM Low Byte, 6 cylinder
	DC.B	$C1		;4400RPM Low Byte, 6 cylinder
	DC.B	$5C		;4500RPM Low Byte, 6 cylinder
	DC.B	$FC		;4600RPM Low Byte, 6 cylinder
	DC.B	$9F		;4700RPM Low Byte, 6 cylinder
	DC.B	$47		;4800RPM Low Byte, 6 cylinder
	DC.B	$F2		;4900RPM Low Byte, 6 cylinder
	DC.B	$A0		;5000RPM Low Byte, 6 cylinder
	DC.B	$52		;5100RPM Low Byte, 6 cylinder
	DC.B	$06		;5200RPM Low Byte, 6 cylinder
	DC.B	$BE		;5300RPM Low Byte, 6 cylinder
	DC.B	$78		;5400RPM Low Byte, 6 cylinder
	DC.B	$34		;5500RPM Low Byte, 6 cylinder
	DC.B	$F3		;5600RPM Low Byte, 6 cylinder
	DC.B	$B5		;5700RPM Low Byte, 6 cylinder
	DC.B	$78		;5800RPM Low Byte, 6 cylinder
	DC.B	$3E		;5900RPM Low Byte, 6 cylinder
	DC.B	$05		;6000RPM Low Byte, 6 cylinder
	DC.B	$CF		;6100RPM Low Byte, 6 cylinder
	DC.B	$9A		;6200RPM Low Byte, 6 cylinder
	DC.B	$67		;6300RPM Low Byte, 6 cylinder
	DC.B	$35		;6400RPM Low Byte, 6 cylinder
	DC.B	$05		;6500RPM Low Byte, 6 cylinder
	DC.B	$D6		;6600RPM Low Byte, 6 cylinder
	DC.B	$A9		;6700RPM Low Byte, 6 cylinder
	DC.B	$7D		;6800RPM Low Byte, 6 cylinder
	DC.B	$53		;6900RPM Low Byte, 6 cylinder
	DC.B	$29		;7000RPM Low Byte, 6 cylinder
	DC.B	$01		;7100RPM Low Byte, 6 cylinder
	DC.B	$DA		;7200RPM Low Byte, 6 cylinder
	DC.B	$B4		;7300RPM Low Byte, 6 cylinder
	DC.B	$8F		;7400RPM Low Byte, 6 cylinder
	DC.B	$6B		;7500RPM Low Byte, 6 cylinder
	DC.B	$48		;7600RPM Low Byte, 6 cylinder
	DC.B	$25		;7700RPM Low Byte, 6 cylinder
	DC.B	$04		;7800RPM Low Byte, 6 cylinder
	DC.B	$E4		;7900RPM Low Byte, 6 cylinder
	DC.B	$C4		;8000RPM Low Byte, 6 cylinder
	DC.B	$A5		;8100RPM Low Byte, 6 cylinder
	DC.B	$87		;8200RPM Low Byte, 6 cylinder
	DC.B	$6A		;8300RPM Low Byte, 6 cylinder
	DC.B	$4D		;8400RPM Low Byte, 6 cylinder
	DC.B	$31		;8500RPM Low Byte, 6 cylinder
	DC.B	$16		;8600RPM Low Byte, 6 cylinder
	DC.B	$FB		;8700RPM Low Byte, 6 cylinder
	DC.B	$E1		;8800RPM Low Byte, 6 cylinder
	DC.B	$C7		;8900RPM Low Byte, 6 cylinder
	DC.B	$AE		;9000RPM Low Byte, 6 cylinder
	DC.B	$96		;9100RPM Low Byte, 6 cylinder
	DC.B	$7E		;9200RPM Low Byte, 6 cylinder
	DC.B	$67		;9300RPM Low Byte, 6 cylinder
	DC.B	$50		;9400RPM Low Byte, 6 cylinder
	DC.B	$39		;9500RPM Low Byte, 6 cylinder
	DC.B	$23		;9600RPM Low Byte, 6 cylinder
	DC.B	$0E		;9700RPM Low Byte, 6 cylinder
	DC.B	$F9		;9800RPM Low Byte, 6 cylinder
	DC.B	$E4		;9900RPM Low Byte, 6 cylinder
	DC.B	$D0		;10000RPM Low Byte, 6 cylinder
	
;RPM tick count lookup, 8 Cylinder	
RPM_TICKS_HIGH_8:
	DC.B	$75		;500RPM High Byte, 8 cylinder
	DC.B	$61		;600RPM High Byte, 8 cylinder
	DC.B	$53		;700RPM High Byte, 8 cylinder
	DC.B	$49		;800RPM High Byte, 8 cylinder
	DC.B	$41		;900RPM High Byte, 8 cylinder
	DC.B	$3A		;1000RPM High Byte, 8 cylinder
	DC.B	$35		;1100RPM High Byte, 8 cylinder
	DC.B	$30		;1200RPM High Byte, 8 cylinder
	DC.B	$2D		;1300RPM High Byte, 8 cylinder
	DC.B	$29		;1400RPM High Byte, 8 cylinder
	DC.B	$27		;1500RPM High Byte, 8 cylinder
	DC.B	$24		;1600RPM High Byte, 8 cylinder
	DC.B	$22		;1700RPM High Byte, 8 cylinder
	DC.B	$20		;1800RPM High Byte, 8 cylinder
	DC.B	$1E		;1900RPM High Byte, 8 cylinder
	DC.B	$1D		;2000RPM High Byte, 8 cylinder
	DC.B	$1B		;2100RPM High Byte, 8 cylinder
	DC.B	$1A		;2200RPM High Byte, 8 cylinder
	DC.B	$19		;2300RPM High Byte, 8 cylinder
	DC.B	$18		;2400RPM High Byte, 8 cylinder
	DC.B	$17		;2500RPM High Byte, 8 cylinder
	DC.B	$16		;2600RPM High Byte, 8 cylinder
	DC.B	$15		;2700RPM High Byte, 8 cylinder
	DC.B	$14		;2800RPM High Byte, 8 cylinder
	DC.B	$14		;2900RPM High Byte, 8 cylinder
	DC.B	$13		;3000RPM High Byte, 8 cylinder
	DC.B	$12		;3100RPM High Byte, 8 cylinder
	DC.B	$12		;3200RPM High Byte, 8 cylinder
	DC.B	$11		;3300RPM High Byte, 8 cylinder
	DC.B	$11		;3400RPM High Byte, 8 cylinder
	DC.B	$10		;3500RPM High Byte, 8 cylinder
	DC.B	$10		;3600RPM High Byte, 8 cylinder
	DC.B	$0F		;3700RPM High Byte, 8 cylinder
	DC.B	$0F		;3800RPM High Byte, 8 cylinder
	DC.B	$0F		;3900RPM High Byte, 8 cylinder
	DC.B	$0E		;4000RPM High Byte, 8 cylinder
	DC.B	$0E		;4100RPM High Byte, 8 cylinder
	DC.B	$0D		;4200RPM High Byte, 8 cylinder
	DC.B	$0D		;4300RPM High Byte, 8 cylinder
	DC.B	$0D		;4400RPM High Byte, 8 cylinder
	DC.B	$0D		;4500RPM High Byte, 8 cylinder
	DC.B	$0C		;4600RPM High Byte, 8 cylinder
	DC.B	$0C		;4700RPM High Byte, 8 cylinder
	DC.B	$0C		;4800RPM High Byte, 8 cylinder
	DC.B	$0B		;4900RPM High Byte, 8 cylinder
	DC.B	$0B		;5000RPM High Byte, 8 cylinder
	DC.B	$0B		;5100RPM High Byte, 8 cylinder
	DC.B	$0B		;5200RPM High Byte, 8 cylinder
	DC.B	$0B		;5300RPM High Byte, 8 cylinder
	DC.B	$0A		;5400RPM High Byte, 8 cylinder
	DC.B	$0A		;5500RPM High Byte, 8 cylinder
	DC.B	$0A		;5600RPM High Byte, 8 cylinder
	DC.B	$0A		;5700RPM High Byte, 8 cylinder
	DC.B	$0A		;5800RPM High Byte, 8 cylinder
	DC.B	$09		;5900RPM High Byte, 8 cylinder
	DC.B	$09		;6000RPM High Byte, 8 cylinder
	DC.B	$09		;6100RPM High Byte, 8 cylinder
	DC.B	$09		;6200RPM High Byte, 8 cylinder
	DC.B	$09		;6300RPM High Byte, 8 cylinder
	DC.B	$09		;6400RPM High Byte, 8 cylinder
	DC.B	$09		;6500RPM High Byte, 8 cylinder
	DC.B	$08		;6600RPM High Byte, 8 cylinder
	DC.B	$08		;6700RPM High Byte, 8 cylinder
	DC.B	$08		;6800RPM High Byte, 8 cylinder
	DC.B	$08		;6900RPM High Byte, 8 cylinder
	DC.B	$08		;7000RPM High Byte, 8 cylinder
	DC.B	$08		;7100RPM High Byte, 8 cylinder
	DC.B	$08		;7200RPM High Byte, 8 cylinder
	DC.B	$08		;7300RPM High Byte, 8 cylinder
	DC.B	$07		;7400RPM High Byte, 8 cylinder
	DC.B	$07		;7500RPM High Byte, 8 cylinder
	DC.B	$07		;7600RPM High Byte, 8 cylinder
	DC.B	$07		;7700RPM High Byte, 8 cylinder
	DC.B	$07		;7800RPM High Byte, 8 cylinder
	DC.B	$07		;7900RPM High Byte, 8 cylinder
	DC.B	$07		;8000RPM High Byte, 8 cylinder
	DC.B	$07		;8100RPM High Byte, 8 cylinder
	DC.B	$07		;8200RPM High Byte, 8 cylinder
	DC.B	$07		;8300RPM High Byte, 8 cylinder
	DC.B	$06		;8400RPM High Byte, 8 cylinder
	DC.B	$06		;8500RPM High Byte, 8 cylinder
	DC.B	$06		;8600RPM High Byte, 8 cylinder
	DC.B	$06		;8700RPM High Byte, 8 cylinder
	DC.B	$06		;8800RPM High Byte, 8 cylinder
	DC.B	$06		;8900RPM High Byte, 8 cylinder
	DC.B	$06		;9000RPM High Byte, 8 cylinder
	DC.B	$06		;9100RPM High Byte, 8 cylinder
	DC.B	$06		;9200RPM High Byte, 8 cylinder
	DC.B	$06		;9300RPM High Byte, 8 cylinder
	DC.B	$06		;9400RPM High Byte, 8 cylinder
	DC.B	$06		;9500RPM High Byte, 8 cylinder
	DC.B	$06		;9600RPM High Byte, 8 cylinder
	DC.B	$06		;9700RPM High Byte, 8 cylinder
	DC.B	$05		;9800RPM High Byte, 8 cylinder
	DC.B	$05		;9900RPM High Byte, 8 cylinder
	DC.B	$05		;10000RPM High Byte, 8 cylinder
	
RPM_TICKS_LOW_8:
	DC.B	$30		;500RPM Low Byte, 8 cylinder
	DC.B	$A8		;600RPM Low Byte, 8 cylinder
	DC.B	$B5		;700RPM Low Byte, 8 cylinder
	DC.B	$3E		;800RPM Low Byte, 8 cylinder
	DC.B	$1B		;900RPM Low Byte, 8 cylinder
	DC.B	$98		;1000RPM Low Byte, 8 cylinder
	DC.B	$44		;1100RPM Low Byte, 8 cylinder
	DC.B	$D4		;1200RPM Low Byte, 8 cylinder
	DC.B	$12		;1300RPM Low Byte, 8 cylinder
	DC.B	$DA		;1400RPM Low Byte, 8 cylinder
	DC.B	$10		;1500RPM Low Byte, 8 cylinder
	DC.B	$9F		;1600RPM Low Byte, 8 cylinder
	DC.B	$78		;1700RPM Low Byte, 8 cylinder
	DC.B	$8D		;1800RPM Low Byte, 8 cylinder
	DC.B	$D7		;1900RPM Low Byte, 8 cylinder
	DC.B	$4C		;2000RPM Low Byte, 8 cylinder
	DC.B	$E7		;2100RPM Low Byte, 8 cylinder
	DC.B	$A2		;2200RPM Low Byte, 8 cylinder
	DC.B	$7A		;2300RPM Low Byte, 8 cylinder
	DC.B	$6A		;2400RPM Low Byte, 8 cylinder
	DC.B	$70		;2500RPM Low Byte, 8 cylinder
	DC.B	$89		;2600RPM Low Byte, 8 cylinder
	DC.B	$B4		;2700RPM Low Byte, 8 cylinder
	DC.B	$ED		;2800RPM Low Byte, 8 cylinder
	DC.B	$34		;2900RPM Low Byte, 8 cylinder
	DC.B	$88		;3000RPM Low Byte, 8 cylinder
	DC.B	$E7		;3100RPM Low Byte, 8 cylinder
	DC.B	$50		;3200RPM Low Byte, 8 cylinder
	DC.B	$C1		;3300RPM Low Byte, 8 cylinder
	DC.B	$3C		;3400RPM Low Byte, 8 cylinder
	DC.B	$BE		;3500RPM Low Byte, 8 cylinder
	DC.B	$47		;3600RPM Low Byte, 8 cylinder
	DC.B	$D6		;3700RPM Low Byte, 8 cylinder
	DC.B	$6B		;3800RPM Low Byte, 8 cylinder
	DC.B	$06		;3900RPM Low Byte, 8 cylinder
	DC.B	$A6		;4000RPM Low Byte, 8 cylinder
	DC.B	$4B		;4100RPM Low Byte, 8 cylinder
	DC.B	$F3		;4200RPM Low Byte, 8 cylinder
	DC.B	$A0		;4300RPM Low Byte, 8 cylinder
	DC.B	$51		;4400RPM Low Byte, 8 cylinder
	DC.B	$05		;4500RPM Low Byte, 8 cylinder
	DC.B	$BD		;4600RPM Low Byte, 8 cylinder
	DC.B	$77		;4700RPM Low Byte, 8 cylinder
	DC.B	$35		;4800RPM Low Byte, 8 cylinder
	DC.B	$F5		;4900RPM Low Byte, 8 cylinder
	DC.B	$B8		;5000RPM Low Byte, 8 cylinder
	DC.B	$7D		;5100RPM Low Byte, 8 cylinder
	DC.B	$45		;5200RPM Low Byte, 8 cylinder
	DC.B	$0E		;5300RPM Low Byte, 8 cylinder
	DC.B	$DA		;5400RPM Low Byte, 8 cylinder
	DC.B	$A7		;5500RPM Low Byte, 8 cylinder
	DC.B	$77		;5600RPM Low Byte, 8 cylinder
	DC.B	$48		;5700RPM Low Byte, 8 cylinder
	DC.B	$1A		;5800RPM Low Byte, 8 cylinder
	DC.B	$EE		;5900RPM Low Byte, 8 cylinder
	DC.B	$C4		;6000RPM Low Byte, 8 cylinder
	DC.B	$9B		;6100RPM Low Byte, 8 cylinder
	DC.B	$73		;6200RPM Low Byte, 8 cylinder
	DC.B	$4D		;6300RPM Low Byte, 8 cylinder
	DC.B	$28		;6400RPM Low Byte, 8 cylinder
	DC.B	$04		;6500RPM Low Byte, 8 cylinder
	DC.B	$E1		;6600RPM Low Byte, 8 cylinder
	DC.B	$BF		;6700RPM Low Byte, 8 cylinder
	DC.B	$9E		;6800RPM Low Byte, 8 cylinder
	DC.B	$7E		;6900RPM Low Byte, 8 cylinder
	DC.B	$5F		;7000RPM Low Byte, 8 cylinder
	DC.B	$41		;7100RPM Low Byte, 8 cylinder
	DC.B	$23		;7200RPM Low Byte, 8 cylinder
	DC.B	$07		;7300RPM Low Byte, 8 cylinder
	DC.B	$EB		;7400RPM Low Byte, 8 cylinder
	DC.B	$D0		;7500RPM Low Byte, 8 cylinder
	DC.B	$B6		;7600RPM Low Byte, 8 cylinder
	DC.B	$9C		;7700RPM Low Byte, 8 cylinder
	DC.B	$83		;7800RPM Low Byte, 8 cylinder
	DC.B	$6B		;7900RPM Low Byte, 8 cylinder
	DC.B	$53		;8000RPM Low Byte, 8 cylinder
	DC.B	$3C		;8100RPM Low Byte, 8 cylinder
	DC.B	$25		;8200RPM Low Byte, 8 cylinder
	DC.B	$0F		;8300RPM Low Byte, 8 cylinder
	DC.B	$FA		;8400RPM Low Byte, 8 cylinder
	DC.B	$E5		;8500RPM Low Byte, 8 cylinder
	DC.B	$D0		;8600RPM Low Byte, 8 cylinder
	DC.B	$BC		;8700RPM Low Byte, 8 cylinder
	DC.B	$A9		;8800RPM Low Byte, 8 cylinder
	DC.B	$95		;8900RPM Low Byte, 8 cylinder
	DC.B	$83		;9000RPM Low Byte, 8 cylinder
	DC.B	$70		;9100RPM Low Byte, 8 cylinder
	DC.B	$5E		;9200RPM Low Byte, 8 cylinder
	DC.B	$4D		;9300RPM Low Byte, 8 cylinder
	DC.B	$3C		;9400RPM Low Byte, 8 cylinder
	DC.B	$2B		;9500RPM Low Byte, 8 cylinder
	DC.B	$1B		;9600RPM Low Byte, 8 cylinder
	DC.B	$0A		;9700RPM Low Byte, 8 cylinder
	DC.B	$FB		;9800RPM Low Byte, 8 cylinder
	DC.B	$EB		;9900RPM Low Byte, 8 cylinder
	DC.B	$DC		;10000RPM Low Byte, 8 cylinder
	

ADVANCE_HIGHB:
	DC.B	$06		;  0 deg
	DC.B	$05		;  1 deg
	DC.B	$05		;  2 deg
	DC.B	$05		;  3 deg
	DC.B	$05		;  4 deg
	DC.B	$05		;  5 deg
	DC.B	$05		;  6 deg
	DC.B	$05		;  7 deg
	DC.B	$05		;  8 deg
	DC.B	$05		;  9 deg
	DC.B	$05		; 10 deg
	DC.B	$04		; 11 deg
	DC.B	$04		; 12 deg
	DC.B	$04		; 13 deg
	DC.B	$04		; 14 deg
	DC.B	$04		; 15 deg
	DC.B	$04		; 16 deg
	DC.B	$04		; 17 deg
	DC.B	$04		; 18 deg
	DC.B	$04		; 19 deg
	DC.B	$04		; 20 deg
	DC.B	$03		; 21 deg
	DC.B	$03		; 22 deg
	DC.B	$03		; 23 deg
	DC.B	$03		; 24 deg
	DC.B	$03		; 25 deg
	DC.B	$03		; 26 deg
	DC.B	$03		; 27 deg
	DC.B	$03		; 28 deg
	DC.B	$03		; 29 deg
	DC.B	$03		; 30 deg
	DC.B	$02		; 31 deg
	DC.B	$02		; 32 deg
	DC.B	$02		; 33 deg
	DC.B	$02		; 34 deg
	DC.B	$02		; 35 deg
	DC.B	$02		; 36 deg
	DC.B	$02		; 37 deg
	DC.B	$02		; 38 deg
	DC.B	$02		; 39 deg
	DC.B	$02		; 40 deg
	DC.B	$01		; 41 deg
	DC.B	$01		; 42 deg
	DC.B	$01		; 43 deg
	DC.B	$01		; 44 deg
	DC.B	$01		; 45 deg
	DC.B	$01		; 46 deg
	DC.B	$01		; 47 deg
	DC.B	$01		; 48 deg
	DC.B	$01		; 49 deg
	DC.B	$01		; 50 deg
	DC.B	$00		; 51 deg
	DC.B	$00		; 52 deg
	DC.B	$00		; 53 deg
	DC.B	$00		; 54 deg
	DC.B	$00		; 55 deg
	DC.B	$00		; 56 deg
	DC.B	$00		; 57 deg
	DC.B	$00		; 58 deg
	DC.B	$00		; 59 deg
	
ADVANCE_LOWB:
	DC.B	$00		;  0 deg
	DC.B	$E6		;  1 deg
	DC.B	$CD		;  2 deg
	DC.B	$B3		;  3 deg
	DC.B	$9A		;  4 deg
	DC.B	$80		;  5 deg
	DC.B	$66		;  6 deg
	DC.B	$4D		;  7 deg
	DC.B	$33		;  8 deg
	DC.B	$1A		;  9 deg
	DC.B	$00		; 10 deg
	DC.B	$E6		; 11 deg
	DC.B	$CD		; 12 deg
	DC.B	$B3		; 13 deg
	DC.B	$9A		; 14 deg
	DC.B	$80		; 15 deg
	DC.B	$66		; 16 deg
	DC.B	$4D		; 17 deg
	DC.B	$33		; 18 deg
	DC.B	$1A		; 19 deg
	DC.B	$00		; 20 deg
	DC.B	$E6		; 21 deg
	DC.B	$CD		; 22 deg
	DC.B	$B3		; 23 deg
	DC.B	$9A		; 24 deg
	DC.B	$80		; 25 deg
	DC.B	$66		; 26 deg
	DC.B	$4D		; 27 deg
	DC.B	$33		; 28 deg
	DC.B	$1A		; 29 deg
	DC.B	$00		; 30 deg
	DC.B	$E6		; 31 deg
	DC.B	$CD		; 32 deg
	DC.B	$B3		; 33 deg
	DC.B	$9A		; 34 deg
	DC.B	$80		; 35 deg
	DC.B	$66		; 36 deg
	DC.B	$4D		; 37 deg
	DC.B	$33		; 38 deg
	DC.B	$1A		; 39 deg
	DC.B	$00		; 40 deg
	DC.B	$E6		; 41 deg
	DC.B	$CD		; 42 deg
	DC.B	$B3		; 43 deg
	DC.B	$9A		; 44 deg
	DC.B	$80		; 45 deg
	DC.B	$66		; 46 deg
	DC.B	$4D		; 47 deg
	DC.B	$33		; 48 deg
	DC.B	$1A		; 49 deg
	DC.B	$00		; 50 deg
	DC.B	$E6		; 51 deg
	DC.B	$CD		; 52 deg
	DC.B	$B3		; 53 deg
	DC.B	$9A		; 54 deg
	DC.B	$80		; 55 deg
	DC.B	$66		; 56 deg
	DC.B	$4D		; 57 deg
	DC.B	$33		; 58 deg
	DC.B	$1A		; 59 deg

	


;*********************************************
;PROGRAMMABLE DATA AREA
;*********************************************

	org 	$FA40

LOAD_CALIBRATION:
;Default calibrartion is for a Freescale MPX4250AP sensor
	DC.B	100T
	DC.B	10T
	DC.B	11T
	DC.B	12T
	DC.B	13T
	DC.B	14T
	DC.B	15T
	DC.B	16T
	DC.B	17T
	DC.B	18T
	DC.B	19T
	DC.B	20T
	DC.B	21T
	DC.B	22T
	DC.B	23T
	DC.B	24T
	DC.B	25T
	DC.B	26T
	DC.B	27T
	DC.B	28T
	DC.B	29T
	DC.B	30T
	DC.B	31T
	DC.B	32T
	DC.B	33T
	DC.B	34T
	DC.B	35T
	DC.B	36T
	DC.B	37T
	DC.B	38T
	DC.B	39T
	DC.B	40T
	DC.B	41T
	DC.B	42T
	DC.B	43T
	DC.B	44T
	DC.B	45T
	DC.B	46T
	DC.B	47T
	DC.B	48T
	DC.B	49T
	DC.B	50T
	DC.B	51T
	DC.B	52T
	DC.B	53T
	DC.B	54T
	DC.B	55T
	DC.B	56T
	DC.B	57T
	DC.B	58T
	DC.B	59T
	DC.B	59T
	DC.B	60T
	DC.B	61T
	DC.B	62T
	DC.B	63T
	DC.B	64T
	DC.B	65T
	DC.B	66T
	DC.B	67T
	DC.B	68T
	DC.B	69T
	DC.B	70T
	DC.B	71T
	DC.B	72T
	DC.B	73T
	DC.B	74T
	DC.B	75T
	DC.B	76T
	DC.B	77T
	DC.B	78T
	DC.B	79T
	DC.B	80T
	DC.B	81T
	DC.B	82T
	DC.B	83T
	DC.B	84T
	DC.B	85T
	DC.B	86T
	DC.B	87T
	DC.B	88T
	DC.B	89T
	DC.B	90T
	DC.B	91T
	DC.B	92T
	DC.B	93T
	DC.B	94T
	DC.B	95T
	DC.B	96T
	DC.B	97T
	DC.B	98T
	DC.B	99T
	DC.B	100T
	DC.B	101T
	DC.B	102T
	DC.B	103T
	DC.B	104T
	DC.B	105T
	DC.B	106T
	DC.B	107T
	DC.B	108T
	DC.B	109T
	DC.B	110T
	DC.B	110T
	DC.B	111T
	DC.B	112T
	DC.B	113T
	DC.B	114T
	DC.B	115T
	DC.B	116T
	DC.B	117T
	DC.B	118T
	DC.B	119T
	DC.B	120T
	DC.B	121T
	DC.B	122T
	DC.B	123T
	DC.B	124T
	DC.B	125T
	DC.B	126T
	DC.B	127T
	DC.B	128T
	DC.B	129T
	DC.B	130T
	DC.B	131T
	DC.B	132T
	DC.B	133T
	DC.B	134T
	DC.B	135T
	DC.B	136T
	DC.B	137T
	DC.B	138T
	DC.B	139T
	DC.B	140T
	DC.B	141T
	DC.B	142T
	DC.B	143T
	DC.B	144T
	DC.B	145T
	DC.B	146T
	DC.B	147T
	DC.B	148T
	DC.B	149T
	DC.B	150T
	DC.B	151T
	DC.B	152T
	DC.B	153T
	DC.B	154T
	DC.B	155T
	DC.B	156T
	DC.B	157T
	DC.B	158T
	DC.B	159T
	DC.B	160T
	DC.B	160T
	DC.B	161T
	DC.B	162T
	DC.B	163T
	DC.B	164T
	DC.B	165T
	DC.B	166T
	DC.B	167T
	DC.B	168T
	DC.B	169T
	DC.B	170T
	DC.B	171T
	DC.B	172T
	DC.B	173T
	DC.B	174T
	DC.B	175T
	DC.B	176T
	DC.B	177T
	DC.B	178T
	DC.B	179T
	DC.B	180T
	DC.B	181T
	DC.B	182T
	DC.B	183T
	DC.B	184T
	DC.B	185T
	DC.B	186T
	DC.B	187T
	DC.B	188T
	DC.B	189T
	DC.B	190T
	DC.B	191T
	DC.B	192T
	DC.B	193T
	DC.B	194T
	DC.B	195T
	DC.B	196T
	DC.B	197T
	DC.B	198T
	DC.B	199T
	DC.B	200T
	DC.B	201T
	DC.B	202T
	DC.B	203T
	DC.B	204T
	DC.B	205T
	DC.B	206T
	DC.B	207T
	DC.B	208T
	DC.B	209T
	DC.B	210T
	DC.B	210T
	DC.B	211T
	DC.B	212T
	DC.B	213T
	DC.B	214T
	DC.B	215T
	DC.B	216T
	DC.B	217T
	DC.B	218T
	DC.B	219T
	DC.B	220T
	DC.B	221T
	DC.B	222T
	DC.B	223T
	DC.B	224T
	DC.B	225T
	DC.B	226T
	DC.B	227T
	DC.B	228T
	DC.B	229T
	DC.B	230T
	DC.B	231T
	DC.B	232T
	DC.B	233T
	DC.B	234T
	DC.B	235T
	DC.B	236T
	DC.B	237T
	DC.B	238T
	DC.B	239T
	DC.B	240T
	DC.B	241T
	DC.B	242T
	DC.B	243T
	DC.B	244T
	DC.B	245T
	DC.B	246T
	DC.B	247T
	DC.B	248T
	DC.B	249T
	DC.B	250T
	DC.B	251T
	DC.B	252T
	DC.B	253T
	DC.B	254T
	DC.B	255T
	DC.B	255T
	DC.B	255T
	DC.B	255T
	DC.B	255T
	DC.B	100T
LOAD_CALIBRATION_END:

        
;The RPM Bins represent the number of microseconds elapsed between each PIP signal
;4 Cylinder = 2 PIP signals per engine crank revolution
;6 cylinder = 3 PIP signals per engine crank revolution
;8 cylinder = 4 PIP signals per engine crank revolution

;4 cylinder: uS between PIP signals = 1000000 * ((1/(RPM/60))/2)
;6 cylinder: uS between PIP signals = 1000000 * ((1/(RPM/60))/3)
;8 cylinder: uS between PIP signals = 1000000 * ((1/(RPM/60))/4)

;Note the default configuration targets a 4 cylinder setup!


;Ignition config 0

SAVED_CONFIG_DATA_0:
SAVED_RPMBINS_0:
	DC.B	10T		; 1000 RPM
	DC.B	20T		; 2000 RPM
	DC.B	30T		; 3000 RPM
	DC.B	40T		; 4000 RPM
	DC.B	45T		; 4500 RPM
	DC.B	50T		; 5000 RPM
	DC.B	55T		; 5500 RPM
	DC.B	60T		; 6000 RPM
	DC.B	65T		; 6500 RPM
	DC.B	70T		; 7000 RPM

;Using a MPX4250 pressure transducer, the Kpa values
;will map 1:1 to the values converted by the Analog-Digital Converter.					
SAVED_MAPBINS_0:
	DC.B	20T		; 20 Kpa
	DC.B	50T		; 50 Kpa
	DC.B	60T		; 60 Kpa
	DC.B	70T		; 70 Kpa
	DC.B	100T	; 100 Kpa
	DC.B	135T	; 135 Kpa
	DC.B	160T	; 160 Kpa
	DC.B	180T	; 180 Kpa
	DC.B	200T	; 200 Kpa
	DC.B	230T	; 230 Kpa

;Ignition Map is RPM across the X axis; MAP value down the Y axis.
;The values are the actual ignition advance values in degrees.
SAVED_IGNITION_MAP_0:
	DC.B 	12T, 20T, 25T, 27T, 30T, 32T, 35T, 36T, 36T, 36T
	DC.B 	12T, 20T, 25T, 27T, 30T, 32T, 35T, 36T, 36T, 36T
	DC.B 	15T, 20T, 25T, 27T, 30T, 32T, 35T, 36T, 36T, 36T
	DC.B 	15T, 20T, 25T, 27T, 30T, 32T, 35T, 36T, 36T, 36T
	DC.B 	15T, 20T, 25T, 27T, 28T, 29T, 30T, 33T, 34T, 34T
	DC.B 	12T, 20T, 23T, 23T, 23T, 25T, 25T, 25T, 25T, 25T
	DC.B 	12T, 18T, 20T, 22T, 22T, 23T, 23T, 23T, 24T, 24T
	DC.B 	10T, 15T, 20T, 22T, 22T, 22T, 22T, 22T, 22T, 22T
	DC.B 	10T, 15T, 20T, 22T, 22T, 22T, 22T, 22T, 22T, 22T
	DC.B 	10T, 15T, 20T, 22T, 22T, 22T, 22T, 22T, 22T, 22T

SAVED_CONFIG_CYLINDERS_0:
	DC.B	$04					;number of cylinders - 4,6 or 8

SAVED_USER_OUTPUT_CONFIG_0:		;bits 0-3 indicate output type- 1 = RPM switch, 0 = MAP switch
	DC.B	$FF					;bits 4-7 indicate output mode- 1 = "on" when configured limit is exceeded, 0 = "off" when configured limit is exceeded
	
SAVED_USER_OUTPUT1_0:
	DC.B	10T
SAVED_USER_OUTPUT2_0:
	DC.B	12T
SAVED_USER_OUTPUT3_0:
	DC.B	13T
SAVED_USER_OUTPUT4_0:
	DC.B	14T
SAVED_REV_LIMITER_0:	;Rev limiter RPM
	DC.B	76T
SAVED_RPM_SHIFT_LIGHT_0:
	DC.B	70T			;shift light RPM

SAVED_CONFIG_DATA_END_0:


;Ignition config 1

SAVED_CONFIG_DATA_1:
SAVED_RPMBINS_1:
	DC.B	10T		; 1000 RPM
	DC.B	20T		; 2000 RPM
	DC.B	30T		; 3000 RPM
	DC.B	40T		; 4000 RPM
	DC.B	45T		; 4500 RPM
	DC.B	50T		; 5000 RPM
	DC.B	55T		; 5500 RPM
	DC.B	60T		; 6000 RPM
	DC.B	65T		; 6500 RPM
	DC.B	70T		; 7000 RPM

;Using a MPX4250 pressure transducer, the Kpa values
;will map 1:1 to the values converted by the Analog-Digital Converter.					
SAVED_MAPBINS_1:
	DC.B	20T		; 20 Kpa
	DC.B	50T		; 50 Kpa
	DC.B	60T		; 60 Kpa
	DC.B	70T		; 70 Kpa
	DC.B	100T	; 100 Kpa
	DC.B	135T	; 135 Kpa
	DC.B	160T	; 160 Kpa
	DC.B	180T	; 180 Kpa
	DC.B	200T	; 200 Kpa
	DC.B	230T	; 230 Kpa

;Ignition Map is RPM across the X axis; MAP value down the Y axis.
;The values are the actual ignition advance values in degrees.
SAVED_IGNITION_MAP_1:
	DC.B 	12T, 20T, 25T, 27T, 30T, 32T, 35T, 36T, 36T, 36T
	DC.B 	12T, 20T, 25T, 27T, 30T, 32T, 35T, 36T, 36T, 36T
	DC.B 	15T, 20T, 25T, 27T, 30T, 32T, 35T, 36T, 36T, 36T
	DC.B 	15T, 20T, 25T, 27T, 30T, 32T, 35T, 36T, 36T, 36T
	DC.B 	15T, 20T, 25T, 27T, 28T, 29T, 30T, 33T, 34T, 34T
	DC.B 	12T, 20T, 23T, 23T, 23T, 25T, 25T, 25T, 25T, 25T
	DC.B 	12T, 18T, 20T, 22T, 22T, 23T, 23T, 23T, 24T, 24T
	DC.B 	10T, 15T, 20T, 22T, 22T, 22T, 22T, 22T, 22T, 22T
	DC.B 	10T, 15T, 20T, 22T, 22T, 22T, 22T, 22T, 22T, 22T
	DC.B 	10T, 15T, 20T, 22T, 22T, 22T, 22T, 22T, 22T, 22T

SAVED_CONFIG_CYLINDERS_1:
	DC.B	$04					;number of cylinders - 4,6 or 8

SAVED_USER_OUTPUT_CONFIG_1:		;bits 0-3 indicate output type- 1 = RPM switch, 0 = MAP switch
	DC.B	$FF					;bits 4-7 indicate output mode- 1 = "on" when configured limit is exceeded, 0 = "off" when configured limit is exceeded
	
SAVED_USER_OUTPUT1_1:
	DC.B	10T
SAVED_USER_OUTPUT2_1:
	DC.B	12T
SAVED_USER_OUTPUT3_1:
	DC.B	13T
SAVED_USER_OUTPUT4_1:
	DC.B	14T
SAVED_REV_LIMITER_1:	;Rev limiter RPM
	DC.B	76T
SAVED_RPM_SHIFT_LIGHT_1:
	DC.B	70T			;shift light RPM

SAVED_CONFIG_DATA_END_1:


;*********************************************
; Global configuration data
;*********************************************
GLOBAL_CONFIG_DATA:
GLOBAL_ENABLE_DUAL_CONFIG:
	DC.B	0T				;0 = disable dual config; 1 = enable
PIP_NOISE_FILTER_LEVEL:		;number of times to iterate for PIP noise filter
	DC.B	10T

GLOBAL_EXTENDED_DATA:
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
	DC.B	0T
GLOBAL_CONFIG_DATA_END:


;*********************************************
;END PROGRAMMABLE DATA AREA
;*********************************************

; disabled to allow bootloader to take over managment of this
;	org	FLBPR		; protect vector block from flash erase routine (see AN1831)
;	DC.B	$F8
END  
